!********************************************************
!
      subroutine  extrap_sable(xe)
!
!
!   calcul des termes correctif pour les flux de depots et flux horizontaux
!    pour la couche de fond
!********************************************************
!
#ifdef key_sedim_anc
use comsedim
use comsubstance, only : ws3,flx_s2w,flx_w2s
implicit none



      real(kind=rsh),dimension(imin:imax,jmin:jmax)::	 xe,uetoile

!
      real(kind=rsh)     :: altc1,ep,htot,extrap,rouse,som,dzcche,hzed
      real(kind=rsh)     :: einstein,alogaltc1sz0
      integer            :: izz,i,j,ivp
      integer,parameter        :: nbcche=20
      real(kind=rsh),parameter :: aref=0.02
      real(kind=rsh),dimension(1:nbcche+1) ::hzi

!
            corflux=1.
            corfluy=1.
!
      do j=jmin+1,jmax-1
        do i=ig(j)+1,id(j)-1
          uetoile(i,j)=(tenfon(i,j)/1000.)**0.5
!
          do ivp=ndsable,nfsable
!
          altc1=sig(1)*(h0(i,j)+xe(i,j))
          ep=sigw(1)*(h0(i,j)+xe(i,j))
!
          htot=h0(i,j)+xe(i,j)  
!
          if(altc1.le.aref)then
            extrap=1.
            corflux(ivp,i,j)=1.
            corfluy(ivp,i,j)=1.
          else
!
          rouse=ws3(1,ivp,i,j)                                       &
     &            /(0.4*amax1(uetoile(i,j),0.8*ws3(1,ivp,i,j)))
!*****integrale concentration dans premiere couche**************************
!
          hzi(1)=ep
!
          do izz=1,nbcche
              hzi(izz+1)=hzi(izz)-(hzi(1)-aref)/2.**izz
          enddo     
!
          hzi(nbcche+1)=aref
!
          som=0.
          do izz=1,nbcche
              hzed=.5*(hzi(izz)+hzi(izz+1))
              dzcche=hzi(izz)-hzi(izz+1) 
              som=som+dzcche*((htot-hzed)/hzed)**rouse
          enddo 
         som=som*(aref/(htot-aref))**rouse
!
          extrap=(ep-aref)/som 
!
!***integrale profil concentration*vitesse log  dans premiere couche********
!
          hzi(1)=ep
!
          do izz=1,nbcche
              hzi(izz+1)=hzi(izz)-(hzi(1)-aref)/2.**izz
          enddo        
          hzi(nbcche+1)=aref
!
          einstein=0.
          do izz=1,nbcche
              hzed=.5*(hzi(izz)+hzi(izz+1))
              dzcche=hzi(izz)-hzi(izz+1)

              einstein=einstein+dzcche*((htot-hzed)/hzed)**rouse      &  
     &                         *log(hzed/z0sed(i,j))

            



          enddo 
!
!
          alogaltc1sz0=log(altc1/z0sed(i,j))
!
          einstein=einstein*(aref/(htot-aref))**rouse                   &
     &                     *extrap/alogaltc1sz0/ep
!
!********************************************************
!
!
!
          if(htx(i,j).le.hm)then
          corflux(ivp,i,j)=einstein*alogaltc1sz0/log(htot/(exp(1.)*z0sed(i,j)))
!
          else
            corflux(ivp,i,j)=einstein
          endif
          if(hty(i,j).le.hm)then
          corfluy(ivp,i,j)=einstein*alogaltc1sz0/log(htot/(exp(1.)*z0sed(i,j)))
          else
            corfluy(ivp,i,j)=einstein
          endif
!
          endif
!
          flx_w2s(ivp,i,j)=flx_w2s(ivp,i,j)*extrap
              enddo
            enddo
          enddo
!
! on met les corflux aux bords des mailles(en u et v)
      do j=jmin+1,jmax-1
        do i=ig(j)+1,id(j)-1
!
          do ivp=ndsable,nfsable
           corflux(ivp,i,j)=(corflux(ivp,i,j)+corflux(ivp,i+1,j))/2
           corfluy(ivp,i,j)=(corflux(ivp,i,j)+corflux(ivp,i,j+1))/2
           enddo
        enddo
      enddo

#endif
          end
