!***********************************************************************
      subroutine inifond
!
!     initialisation du fond non uniforme
!***********************************************************************
!
#ifdef key_sedim_anc
use parametres
use comvars2d, only : ig,id
use comsedim
use comsubstance, only : nvpc,nvp,nv_state,irk_mod

implicit none

!
!
      integer i,j,k,iv,igsed,idsed,jbsed,jhsed,ksdma
      real somalp,dzsf,dzsunis,csedunis
      character*50 filesable,filevase
      real(kind=rsh), DIMENSION(imin:imax,jmin:jmax) :: vase,sabl
      real cstest
!
      filesable='../entrees/sables.nc'
      filevase='../entrees/vases.nc'
!
	call ionc_ouvrel(filesable)
        call ionc_litr4_xy(filesable,'sable',sabl,                      &
     &                   imin,imax,jmin,jmax)
!
       call ionc_fermer(filesable)	
!
!
	call ionc_ouvrel(filevase)
        call ionc_litr4_xy(filevase,'vase',vase,                        &
     &                   imin,imax,jmin,jmax)
!
       call ionc_fermer(filevase)
!
!
!
      do j=jmin,jmax
         do i=ig(j),id(j)
!
          z0sed(i,j)=z0seduni          
          hsed(i,j)=1.
          ksmi(i,j)=1
          ksma(i,j)=1
!
          do k=ksmi(i,j),ksma(i,j)

            if(sabl(i,j).eq.0.) cini_sed(irk_mod(3))=0.
             if(sabl(i,j).eq.1.) cini_sed(irk_mod(3))=0.5
             if(sabl(i,j).eq.2.) cini_sed(irk_mod(3))=0.5
             if(sabl(i,j).eq.3.) cini_sed(irk_mod(3))=0.5
             if(sabl(i,j).eq.4.) cini_sed(irk_mod(3))=0.

             if(vase(i,j).eq.0.) cini_sed(irk_mod(1))=0.
             if(vase(i,j).eq.1.) cini_sed(irk_mod(1))=1.-cini_sed(irk_mod(3))
             if(vase(i,j).eq.2.) cini_sed(irk_mod(1))=1.-cini_sed(irk_mod(3))
             if(vase(i,j).eq.3.) cini_sed(irk_mod(1))=1.-cini_sed(irk_mod(3))
!
             if(sabl(i,j).eq.0.) cini_sed(irk_mod(2))=0.
             if(sabl(i,j).eq.1.) cini_sed(irk_mod(2))=0.
             if(sabl(i,j).eq.2.) cini_sed(irk_mod(2))=0.
             if(sabl(i,j).eq.3.) cini_sed(irk_mod(2))=0.
             if(sabl(i,j).eq.4.) cini_sed(irk_mod(2))=1.-cini_sed(irk_mod(1))-cini_sed(irk_mod(3))
!
!
!
             cstest=cini_sed(1)+cini_sed(2)+cini_sed(3)
!
!             if(cstest.ne.0.) then
             if(cstest.ne.1.) then
!                write(*,*)'attention pb ds inifond en maille:',i,j       
!     &       ,cini_sed(1),cini_sed(2),cini_sed(3),cstest
                cini_sed(3)=0.
                cini_sed(2)=0.
                cini_sed(1)=0.
                 hsed(i,j)=0.
                ksmi(i,j)=1
                ksma(i,j)=0
             endif
!             endif
!
            c_sedtot(k,i,j)=cseduni
            somalp=0.
            do iv=1,nvpc
!             - variables constitutives: cini_sed en pourcentage de masse de sediment
              cv_sed(iv,k,i,j)=cini_sed(iv)*c_sedtot(k,i,j)
              somalp=somalp+cv_sed(iv,k,i,j)/(ros(iv)+epsilon)
            enddo
            poro(k,i,j)=1.-somalp
            do iv=nvpc+1,nvp
!             - variables non constitutives: cini_sed en conc/kg de sediment
              cv_sed(iv,k,i,j)=cini_sed(iv)*c_sedtot(k,i,j)
            enddo
!cval            do iv=nvp+1,nvar
            do iv=nvp+1,nv_state
!             - variables dissoutes: cini_sed en conc/m3 d eau interstitielle
              cv_sed(iv,k,i,j)=cini_sed(iv)
            enddo
            cv_sed(-1,k,i,j)=tini_sed
            cv_sed( 0,k,i,j)=sini_sed
         enddo
!      endif
!
!
! modif pas de sediment dans la zone 0-10m a cause de la resolution des vagues
!         if(h0(i,j).lt.10)then
!                              
!          hsed(i,j)=0.
!          ksmi(i,j)=1
!          ksma(i,j)=0
!          endif
!
      enddo
      enddo
!
!
      if(imails.eq.0)then
!       maillage regulier
!       -----------------
        do j=jmin,jmax
          do i=imin,imax
            if(ksma(i,j).ne.0)then
              dzsf=hsed(i,j)/float(ksma(i,j)-ksmi(i,j)+1)
              do k=ksmi(i,j),ksma(i,j)-1
                dzs(k,i,j)=dzsf
              enddo
              k=ksma(i,j)
              dzs(k,i,j)=dzsf
            endif
          enddo
        enddo
      else 
!       
        write(*,*)'attention dans le sédiment:'
        write(*,*)'maillage irrégulier non programmé'
        stop
      endif
!
#endif
      end   
