!********************************************************
!
subroutine marsedim(uz,vz,temp,sal,cv_wat)
!
!********************************************************
!
#ifdef key_sedim_anc
        use comsedim
        use comsubstance, only : nb_var,tocd,ws3,nvp,nvpc,flx_s2w,flx_w2s,  &
                                 l_benthic,l_pelagic
implicit none
!

      real(kind=rsh),dimension(kmax,imin:imax,jmin:jmax) :: sal,temp,uz,vz
      real(kind=rsh),dimension (nb_var,kmax,imin:imax,jmin:jmax) :: cv_wat

       integer i,j,iv,ivp,k,it
       real(kind=rsh)    :: a,tmp,dens,cmespc,vit,z,tocdpe,depo
       real(kind=rsh)    :: sigfrot,zfrot
       real(kind=rsh),dimension(imin:imax,jmin:jmax)    :: raphbx,raphby, &
                                                           frofonx,frofony, &
                                                           eptot
!
! executable statement
!-----------------------
!
! pas de temps
!--------------
!
! calcul de la densite
!-----------------------
!
       dtt=0.5*dt
! 
      if(icon.eq.0)then
        a=0.0
        tmp=0.0
       else
        a=.0008
        tmp=-.00016
       endif

       do  j=jmin,jmax
        do  i=ig(j),id(j)

        denseau(i,j)=1000.0*(1.0+a*max(0.0,sal(1,i,j))+tmp*temp(1,i,j))
        dens=0.
        do iv=1,nvpc
         cmespc=max(0.0,cv_wat(iv,1,i,j))
         dens=-denseau(i,j)*cmespc/ros(iv)+cmespc+dens
        enddo
        denseau(i,j)=denseau(i,j)+dens
        denseau(i,j)=1035.
! modif

!
        end do
       end do
!
! calcul de la tension de fond vu par le sediment
!-------------------------------------------------
!
      do j=jmin,jmax
        do i=imin,imax
          raphbx(i,j)=0.
          raphby(i,j)=0.
!modif
          frofonx(i,j)=0.
          frofony(i,j)=0.
        enddo
        do i=ig(j),id(j)
          raphbx(i,j)=abs(uz(1,i,j))/(abs(uz(1,i,j))+epsilon)
         raphby(i,j)=abs(vz(1,i,j))/(abs(vz(1,i,j))+epsilon)
        enddo
      enddo
!
       zfrot=0.5
      do j=jmin+1,jmax-1
        do i=ig(j)+1,id(j)-1
          sigfrot=zfrot/(htx(i,j)+epsilon)
          do k=1,kmax
             if(sig(k).ge.sigfrot) goto 1000
          enddo
          k=kmax
1000     continue
         z=max(epsilon,abs(sig(k)*htx(i,j)))
          vit=sqrt(uz(k,i,j)**2+0.0625*(vz(k,i,j)+vz(k,i+1,j) &
               +vz(k,i,j-1)+vz(k,i+1,j-1))**2)*uz(k,i,j)             
         frofonx(i,j)=0.16*(log(z/z0sed(i,j)))**(-2)*vit
         
          sigfrot=zfrot/(hty(i,j)+epsilon)
          do k=1,kmax
             if(sig(k).ge.sigfrot) goto 2000
          enddo
          k=kmax
2000     continue
         z=max(epsilon,abs(sig(k)*hty(i,j)))
          vit=sqrt(0.0625*(uz(k,i,j)+uz(k,i,j+1)+uz(k,i-1,j+1) &
              +uz(k,i-1,j))**2+vz(k,i,j)**2)*vz(k,i,j)      
         frofony(i,j)=0.16*(log(z/z0sed(i,j)))**(-2)*vit

             

!          z=max(epsilon,abs(sig(1)*htx(i,j)))
!          vit=sqrt(uz(1,i,j)**2+0.0625*(vz(1,i,j)+vz(1,i+1,j)
!     1          +vz(1,i,j-1)+vz(1,i+1,j-1))**2)*uz(1,i,j)
!          frofonx(i,j)=0.16*(log(z/z0sed(i,j)))**(-2)*vit
!
!          z=max(epsilon,abs(sig(1)*hty(i,j)))
!          vit=sqrt(0.0625*(uz(1,i,j)+uz(1,i,j+1)+uz(1,i-1,j+1)
!     1         +uz(1,i-1,j))**2+vz(1,i,j)**2)*vz(1,i,j)
!          frofony(i,j)=0.16*(log(z/z0sed(i,j)))**(-2)*vit
        enddo
      enddo
!
!     calcul de la tension (en N/m2)
!-----------------------------------
!
      do j=jmin+1,jmax
        do i=ig(j)+1,id(j)
          tenfonc(i,j)=sqrt(((frofonx(i,j)*raphbx(i,j)+frofonx(i-1,j) &
                     *raphbx(i-1,j))/(raphbx(i,j) &
                +raphbx(i-1,j)+epsilon))**2+((frofony(i,j)*raphby(i,j) &
      +frofony(i,j-1)*raphby(i,j-1))/(raphby(i,j)+raphby(i,j-1)+epsilon) &
                     )**2)*denseau(i,j)
        enddo
      enddo
!
! modif prise en compte des vagues
      if (.not.l_vague) then
      tenfon=tenfonc
      else
      call tens_vague

      tenfon=tenfonc+tenfonw
      endif



      do j=jmin+1,jmax
        do i=ig(j)+1,id(j)
          do ivp=1,nvp
            tocdpe=tocd(ivp)+0.00001
	    it=ivp
!	    if(biologie) it=iposadvtobio(ivp)
!            if(itypevar(it).ne.1) then
            if(l_benthic(ivp) .and. l_pelagic(ivp)) then
              flx_w2s(ivp,i,j)=ws3(1,ivp,i,j) &
                          *max(0.0,1.0-(tenfon(i,j)/tocdpe)) &
                          *tocd(ivp)/tocdpe 
            else
              flx_w2s(ivp,i,j)=0.
            endif
            depo=flx_w2s(ivp,i,j)*cv_wat(ivp,1,i,j)
            if(depo.le.epsdepot) flx_w2s(ivp,i,j)=0.0
          enddo
        end do
      end do
! 


       do j = jmin,jmax
        do i = imin,imax
          eptot(i,j)=0.0
         do k = ksdmin,ksdmax
           eptot(i,j)=eptot(i,j)+dzs(k,i,j)
         end do
        end do
       end do







  100 format(7(e15.8,1x),i3)

#endif
      end
