!********************************************************************
!     
      subroutine sauvsed
!     
!********************************************************************
!     
!     objet    :  gestion de la reprise de calcul a partir d un etat
!                 enregistre dans un fichier (netcdf ou binaire acces direct)
!                 lors d un run anterieur
!
!
!
!     appelant         : stepu
!                      :
!     appeles          : ionc_creer, ionc_torigine, ionc_creer8
!     appeles          : ionc_creer4_xy, ionc_creer4_xyt
!     appeles          : ionc_creer4_zxyt, ionc_ecrit_t
!     appeles          : ionc_ecritr4_xy, ionc_ecritr4_xyt
!     appeles          : ionc_ecritr4_zxyt, ionc_ecritr8
!                      :
!     canal d ecriture :
!                      :
!     canal de lecture : 26, filrep
!                      :
!     cle cpp          : key_netcdf, key_notra
!                      :
!     variables in     : t, u, uz, xu, v, vz, xv, sal, temp, tz
!     variables in     : ect, bz, nz, kz, vis2d, wz, vish_xe, vish_phi
!     variables in     : filsauvsed, dgac, gwac, dfiac, fisac, ntra
!     variables in     : cdate, h0,sig
!                      :
!     variables out    : 
!                      :
!     variables inout  : tsauv
!                      :
!     dernieres modifs : 11/09/02
!                      :
!***********************************************************
!     
#ifdef key_sedim_anc
use comsedim
use comsubstance, only : nv_adv,flx_s2w,flx_w2s
implicit none

!
      character*3 sufsauv
      character*8 nomc
      character*80 prefsauv
      integer i,j,k,l,iv,ifois
      real(kind=riosh),dimension(imin:imax,jmin:jmax)          ::  xind
      real(kind=riosh),dimension(ksdmax,imin:imax,jmin:jmax)   :: tlits
      real(kind=riosh),dimension(0:kmax+1)                     :: sigsed

      data ifois /0/
!
!************************************************************
!     Executable statements
!************************************************************
!     
!*******************
! creation
!*******************
!
      if(ifois.eq.0 .and. .not.(l_sauvseq)) then
      ifois=1
      call ionc_creer(filsauvsed,dgac,gwac,dfiac,fisac,imin,         &
     &      imax,1,jmin,jmax,1,ksdmin,ksdmax,1,ksdmax,1,sigsed)
!
      call ionc_torigine(filsauvsed,dateref)
      call ionc_creer4_xyt(filsauvsed,'ksmi','s.o','ksmi',0,0)
      call ionc_creer4_xyt(filsauvsed,'ksma','s.o','ksma',0,0)
      call ionc_creer4_zxyt(filsauvsed,'dzs','m','dzs',0,0)
      do iv=-1,nv_adv     ! pour T et S
!cval      do iv=1,nv_adv
       write(nomc,10) iv
       if (iv==-1) nomc='concTEM'
       if (iv==0) nomc='concSAL'
       call                                                             &
     & ionc_creer4_zxyt(filsauvsed,nomc,'u.s.i','concentration ',0,0)
       write(nomc,20) iv
       if (iv==-1) nomc='fxw2sTEM'
       if (iv==0) nomc='fxw2sSAL'
       call ionc_creer4_xyt(filsauvsed,nomc,'u.s.i','flx_w2s ',0,0)
      end do 
!
      endif
!
      if(l_sauvseq.and.t.ge.tsauv) then

      sufsauv='.nc'
      prefsauv='./sauvsed'
      filsauvsed=prefsauv(1:index(prefsauv,' ')-1)//cdate(1:2)//        &
     &  cdate(4:5)//cdate(7:10)//cdate(12:13)//sufsauv
      call ionc_creer(filsauvsed,dgac,gwac,dfiac,fisac,imin,         &
     &      imax,1,jmin,jmax,1,ksdmin,ksdmax,1,ksdmax,1,sigsed)
!
      call ionc_torigine(filsauvsed,dateref)
      call ionc_creer4_xyt(filsauvsed,'ksmi','s.o','ksmi',0,0)
      call ionc_creer4_xyt(filsauvsed,'ksma','s.o','ksma',0,0)
      call ionc_creer4_zxyt(filsauvsed,'dzs','m','dzs',0,0)

      do iv=-1,nv_adv    ! pour T et S
!cval      do iv=1,nv_adv
       write(nomc,10) iv
       if (iv==-1) nomc='concTEM'
       if (iv==0) nomc='concSAL'
       call                                                             &
     & ionc_creer4_zxyt(filsauvsed,nomc,'u.s.i','concentration ',0,0)
       write(nomc,20) iv
       if (iv==-1) nomc='fxw2sTEM'
       if (iv==0) nomc='fxw2sSAL'
       call ionc_creer4_xyt(filsauvsed,nomc,'u.s.i','flx_w2s ',0,0)
      end do 
!
      endif
! 

!*******************
! ecriture
!*******************
!



      if(t.ge.tsauv) then
      call ionc_ecrit_t(filsauvsed,1,t)


      do j=jmin,jmax
       do i=imin,imax
        xind(i,j)=real(ksmi(i,j))
       end do
      end do
      call                                                              &
     & ionc_ecritr4_xyt(filsauvsed,'ksmi',xind,imin,imax,jmin,jmax,1)
      do j=jmin,jmax
       do i=imin,imax
        xind(i,j)=real(ksma(i,j))
       end do
      end do
      call                                                              &
     &  ionc_ecritr4_xyt(filsauvsed,'ksma',xind,imin,imax,jmin,jmax,1)
!
      call                                                              &
     & ionc_ecritr4_zxyt(filsauvsed,'dzs',dzs,                          &
     & imin,imax,jmin,jmax,ksdmax,1)
!
      do iv=-1,nv_adv     ! pour T et S
!cval      do iv = 1,nv_adv
       write(nomc,10) iv
       if (iv==-1) nomc='concTEM'
       if (iv==0) nomc='concSAL'
       do j = jmin,jmax
        do i = imin,imax
         do k = 1,ksdmax
          tlits(k,i,j) = cv_sed(iv,k,i,j)
        enddo
        enddo
       enddo
      call                                                              &
     & ionc_ecritr4_zxyt(filsauvsed,                                    &
     & nomc,tlits,imin,imax,jmin,jmax,ksdmax,1)
       write(nomc,20) iv
       if (iv==-1) nomc='fxw2sTEM'
       if (iv==0) nomc='fxw2sSAL'
       do j = jmin,jmax
        do i = imin,imax
          xind(i,j) = flx_w2s(iv,i,j)
        enddo
       enddo
       call ionc_ecritr4_xyt(filsauvsed,nomc,xind,imin,imax,jmin,jmax,1)
      enddo
      tsauv=t+pasauv
      endif
!

   10 format('concen',i2.2)
   20 format('fx_w2s',i2.2)
!

#endif
      end
