 MODULE comcolig2d

   !!======================================================================
   !!                   ***  MODULE comcolig2d  ***
   !! 
   !!======================================================================

#include "toolcpp.h"

   !! * Modules used
   USE parameters

   !! * Accessibility

   !! * Shared or public module variables

   !! * Private variables
   INTEGER,ALLOCATABLE,DIMENSION(:,:)        :: igdu_old,igdv_old,igdu,igdv
#if defined key_lans_turb || defined key_leray_turb
   INTEGER,ALLOCATABLE,DIMENSION(:,:)        :: igdu_ext,igdv_ext
#endif

   INTEGER,ALLOCATABLE,DIMENSION(:,:)        :: ms,mn      ! wall (mur) at the South and North
   INTEGER,ALLOCATABLE,DIMENSION(:,:)        :: me,mo      ! wall (mur) at the East and West
   INTEGER,ALLOCATABLE,DIMENSION(:,:)        :: whx,why    ! wall at locations hx and hy
   REAL(KIND=rlg),ALLOCATABLE,DIMENSION(:,:) :: av,bv,cv,y2dv,axe,bxe,cxe,y2dxe,y2d_expv

#if defined key_lans_turb || defined key_leray_turb
   REAL(KIND=rsh),ALLOCATABLE,DIMENSION(:,:) :: uz2d, vz2d, uzs2d, vzs2d
#endif
#if defined key_lans_turb || defined key_leray_turb
   REAL(KIND=rsh),ALLOCATABLE,DIMENSION(:,:) :: uv_ext, uv2_ext
#endif

!MBo#ifdef key_lans_turb
#if defined key_lans_turb || defined key_leray_turb
   REAL(KIND=rlg),ALLOCATABLE,DIMENSION(:,:) :: y2dv_aux, y2dv_moy, y2dvs
#endif

 CONTAINS

   !!======================================================================

  SUBROUTINE alloc_comcolig2d

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE alloc_comcolig2d  ***
   !&E
   !&E ** Purpose : 
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by :
   !&E
   !&E ** External calls : 
   !&E
   !&E ** Used ij-arrays : 
   !&E
   !&E ** Modified variables :
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used
   USE comvars2d, ONLY : l_modele2d
   IMPLICIT NONE

   !! * Arguments

   !! * Local declarations

   !!----------------------------------------------------------------------
   !! * Executable part

   IF_NOAGRIF (ALLOCATED(av))PRINT*,"error: comcolig2d allocated"
   ALLOCATE(me(limin  :limaxp1,ljmin  :ljmax  ))
   ALLOCATE(mo(liminm1:limax  ,ljmin  :ljmax  ))
   ALLOCATE(mn(limin  :limax  ,ljmin  :ljmaxp1))
   ALLOCATE(ms(limin  :limax  ,ljminm1:ljmax  ))
   me(:,:)=0
   mo(:,:)=0
   mn(:,:)=0
   ms(:,:)=0
#if ! defined key_dbg
   IF(.NOT.l_modele2d) THEN
#endif
     ALLOCATE(igdu_old(limin:limax,ljmin:ljmax))
     ALLOCATE(igdv_old(limin:limax,ljmin:ljmax))
     igdu_old(:,:)=4
     igdv_old(:,:)=4
#if ! defined key_dbg
   ENDIF
#endif
   ALLOCATE(igdu(liminm1:limaxp1,ljminm1:ljmaxp1))
   ALLOCATE(igdv(liminm1:limaxp1,ljminm1:ljmaxp1))
   igdu(:,:)=4
   igdv(:,:)=4
#if defined key_lans_turb || defined key_leray_turb
   ALLOCATE(igdu_ext(liminm4:limaxp4,ljminm4:ljmaxp4))
   ALLOCATE(igdv_ext(liminm4:limaxp4,ljminm4:ljmaxp4))
   igdu_ext(:,:)=4
   igdv_ext(:,:)=4
#endif

   ALLOCATE(whx(liminm1:limaxp1,ljmin:ljmax))
   ALLOCATE(why(limin:limax,ljminm1:ljmaxp1))
   whx(:,:)=0  ! to manage with sleeping cpus
   why(:,:)=0
   ALLOCATE(av(liminm1:limax,ljminm1:ljmax))
   ALLOCATE(bv(liminm1:limax,ljminm1:ljmax))
   ALLOCATE(cv(liminm1:limax,ljminm1:ljmax))
   ALLOCATE(y2dv(liminm1:limax,ljminm1:ljmax))
#if defined key_lans_turb || defined key_leray_turb
   ALLOCATE(uz2d(liminm4:limaxp4,ljminm4:ljmaxp4))
   ALLOCATE(vz2d(liminm4:limaxp4,ljminm4:ljmaxp4))
   ALLOCATE(uzs2d(liminm2:limaxp2,ljminm2:ljmaxp2))
   ALLOCATE(vzs2d(liminm2:limaxp2,ljminm2:ljmaxp2))
#endif

#if defined key_lans_turb || defined key_leray_turb
   ALLOCATE(uv_ext(liminm4:limaxp4,ljminm4:ljmaxp4))
   ALLOCATE(uv2_ext(liminm4:limaxp4,ljminm4:ljmaxp4))
#endif

!MBo#ifdef key_lans_turb
#if defined key_lans_turb || defined key_leray_turb
   ALLOCATE(y2dv_aux(liminm4:limaxp4,ljminm4:ljmaxp4))
   ALLOCATE(y2dv_moy(liminm1:limax,ljminm1:ljmax))
   ALLOCATE(y2dvs(liminm1:limax,ljminm1:ljmax))
#endif

   ALLOCATE(axe(limin:limax,ljmin:ljmax))
   ALLOCATE(bxe(limin:limax,ljmin:ljmax))
   ALLOCATE(cxe(limin:limax,ljmin:ljmax))
   ALLOCATE(y2dxe(limin:limax,ljmin:ljmax))

   IF(.NOT.l_modele2d) THEN
     ALLOCATE(y2d_expv(imin:imax,ljmin:ljmax))
   ENDIF
   av(:,:)=0.0_rlg;bv(:,:)=1.0_rlg;cv(:,:)=0.0_rlg;y2dv(:,:)=0.0_rlg;
   axe(:,:)=0.0_rlg;bxe(:,:)=1.0_rlg;cxe(:,:)=0.0_rlg;y2dxe(:,:)=valmanq

#if defined key_lans_turb || defined key_leray_turb
   uz2d(:,:)=0.0_rsh; vz2d=0.0_rsh
   uzs2d(:,:)=0.0_rsh; vzs2d=0.0_rsh
#endif

#if defined key_lans_turb || defined key_leray_turb
   uv_ext(:,:)=0.0_rsh; uv2_ext(:,:)=0.0_rsh
#endif

!MBo#ifdef key_lans_turb
#if defined key_lans_turb || defined key_leray_turb
   y2dv_aux(:,:)=0.0_rlg ; y2dv_moy(:,:)=0.0_rlg; y2dvs(:,:)=0.0_rlg
#endif

  END SUBROUTINE alloc_comcolig2d

   !!======================================================================

  SUBROUTINE dealloc_comcolig2d

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE dealloc_comcolig2d  ***
   !&E
   !&E ** Purpose : 
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by :
   !&E
   !&E ** External calls : 
   !&E
   !&E ** Used ij-arrays : 
   !&E
   !&E ** Modified variables :
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used
   USE comvars2d, ONLY : l_modele2d
   IMPLICIT NONE

   !! * Arguments

   !! * Local declarations

   !!----------------------------------------------------------------------
   !! * Executable part

   DEALLOCATE(av,bv,cv,y2dv,axe,bxe,cxe,y2dxe,me,mo,mn,ms,whx,why)
!MBo#ifdef key_lans_turb
#if defined key_lans_turb || defined key_leray_turb
   DEALLOCATE(y2dv_aux, y2dv_moy, y2dvs)
#endif
#if defined key_lans_turb || defined key_leray_turb
   DEALLOCATE(uz2d, vz2d, uzs2d, vzs2d)
#endif

#if defined key_lans_turb || defined key_leray_turb
   DEALLOCATE(uv_ext, uv2_ext)
#endif

   DEALLOCATE(igdu,igdv)

#if defined key_lans_turb || defined key_leray_turb
   DEALLOCATE(igdu_ext,igdv_ext)
#endif
   IF(.NOT.l_modele2d) THEN
     DEALLOCATE(y2d_expv,igdu_old,igdv_old)
   ENDIF

  END SUBROUTINE dealloc_comcolig2d
  !!======================================================================

 END MODULE comcolig2d
