 MODULE comfluvert

   !!======================================================================
   !!                   ***  MODULE comfluvert  ***
   !! 
   !!======================================================================

#include "toolcpp.h"

   !! * Modules used
   USE parameters, ONLY : kmax,limin,limax,ljmin,ljmax,rsh
#ifdef key_substance
   USE parameters, ONLY : nb_var
#endif
   IMPLICIT NONE

   !! * Accessibility

   !! * Shared or public module variables

   !! * Private variables
   REAL(kind=rsh),ALLOCATABLE,DIMENSION(:,:,:)   :: fsalz,ftempz

 CONTAINS

   !!======================================================================

  SUBROUTINE alloc_comfluvert

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE alloc_comfluvert  ***
   !&E
   !&E ** Purpose : 
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by :
   !&E
   !&E ** External calls : 
   !&E
   !&E ** Used ij-arrays : 
   !&E
   !&E ** Modified variables :
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used
   IMPLICIT NONE

   !! * Arguments

   !! * Local declarations

   !!----------------------------------------------------------------------
   !! * Executable part

   IF_NOAGRIF (ALLOCATED(fsalz)) PRINT*,"error: fsalz already allocated"
   ALLOCATE(fsalz(0:kmax,limin:limax,ljmin:ljmax) )
   ALLOCATE(ftempz(0:kmax,limin:limax,ljmin:ljmax) )
   fsalz(:,:,:)=0.0_rsh
   ftempz(:,:,:)=0.0_rsh

  END SUBROUTINE alloc_comfluvert

   !!======================================================================

  SUBROUTINE dealloc_comfluvert

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE dealloc_comfluvert  ***
   !&E
   !&E ** Purpose : 
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by :
   !&E
   !&E ** External calls : 
   !&E
   !&E ** Used ij-arrays : 
   !&E
   !&E ** Modified variables :
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used
   IMPLICIT NONE

   !! * Arguments

   !! * Local declarations

   !!----------------------------------------------------------------------
   !! * Executable part

   DEALLOCATE(fsalz,ftempz)

  END SUBROUTINE dealloc_comfluvert

   !!======================================================================

END MODULE comfluvert
