 MODULE comvarp3d

   !!======================================================================
   !!                   ***  MODULE comvarp3d  ***
   !! 
   !! ** Description :
   !!    uz  : zonal component of total (barotropic+baroclinic) velocity (in m/s)
   !!    vz  : meridional component of total (barotropic+baroclinic) velocity (in m/s)
   !!    uvz : work array containing the zonal or meridional component
   !!          of total (barotropic+baroclinic) velocity (in m/s),
   !!          depending on the current integration (uz if stepu, vz if stepv)
   !!    boz : sea water buoyancy (in m/s2)
   !!    ect : turbulent kinetic energy (in m2/s2)
   !!    psi : kl, epsilon or omega, depending on the type of 2-equation model
   !!
   !!======================================================================
   !! * Modules used
   
   USE parameters

   !! * Shared or public module variables
   REAL(kind=rsh),ALLOCATABLE,DIMENSION(:,:,:) :: uz, vz, ect,psi

#if defined key_lans_turb || defined key_leray_turb
   REAL(kind=rsh),ALLOCATABLE,DIMENSION(:,:,:) :: uzs, vzs 
#endif

#ifdef key_lans_turb
!MBo#if defined key_lans_turb || defined key_leray_turb
   REAL(kind=rsh),ALLOCATABLE,DIMENSION(:,:,:) :: lans_u, lans_v
#endif

   REAL(kind=rsh),ALLOCATABLE,DIMENSION(:,:,:) :: boz,pn2

 END MODULE comvarp3d
