!*********    including dyn3dx_corio.h      ****************************

   !&E---------------------------------------------------------------------
   !&E                 ***  dyn3dx_corio.h  ***
   !&E
   !&E ** Purpose : estimate the trend term relative to the Coriolis
   !&E              parameter for the zonal momentum forcing (3D equation)
   !&E
   !&E ** Description : explicit
   !&E
   !&E ** Called by : included into dyn3dxtlscoef.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Used ij-arrays : vz,fu
   !&E
   !&E ** Modified variables : yz_exp
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  1987-02  (P. Lazure)  Original code
   !&E
   !&E---------------------------------------------------------------------
#if defined key_lans_turb || defined key_leray_turb
   yz_exp(:,i,j)=fu(i,j)*vzs_u(:,i,j)
#else
   yz_exp(:,i,j)=fu(i,j)*vz_u(:,i,j)
#endif

!********* end  including dyn3dx_corio.h      ****************************
