!****************** including dyn3dx_intz  *********************

   !&E---------------------------------------------------------------------
   !&E                 ***  dyn3dx_intz.h  ***
   !&E
   !&E ** Purpose : vertical integration of 3D trend terms :
   !&E              advection, diffusion, external and internal pressure
   !&E              gradient,generator potential,coriolis, bottom stress,
   !&E              wind stress...
   !&E              The integrated results is sent to the 2D trilinear
   !&E              linear system relative to the zonal equations
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by : included into dyn3dxtlscoef.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Used ij-arrays : yz_exp,hzutx,htx
   !&E
   !&E ** Modified variables : yz_exp
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  1987-02  (P. Lazure)  Original code
   !&E       !  1990-10  (F. Dumas ) new formulation
   !&E       !  2007-09  (V. Garnier) homogeneneity of dx dy...
   !&E       !  2008-07  (L. Debreu, M. Honnorat, T. Duhaut) time scheme
   !&E
   !&E---------------------------------------------------------------------

#if defined key_siggen || defined key_gencoord
   intz_exp(i,j)=SUM(yz_exp(:,i,j)*hzutx(:,i,j)*dsigu(:))/htx(i,j)
#else
   intz_exp(i,j)=SUM(yz_exp(:,i,j)*dsigu(:))
#endif

!*************** end including dyn3dx_intz  *********************
