       ! rhs : explicit terms
       y2dv(i,j)=                                       &
                 ! time evolution (u at n-1/2)
                 u(i,j)                                 &
                 ! bottom stress (u at n) explicit part
                 -ft*u(i,j)*cfroe                       &
                 ! coriolis
                +fu(i,j)*v_utmp*halfdt                  &
                 ! explicit part of the sea surface pressure gradient
                  -0.5_rlg*gdt*alphap*forward_dxedx(xec, i, j) &

#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear

                 ! NL advection : u*v*tan(phi)/R (spherical coordinates)

                 +halfdt*u(i,j)*v_utmp*tfiusr(i,j)      &

                 ! non-linear (udu/dx) : explicit part
                 -halfdt*u(i,j)*centered_dudx(u, i, j) &
#endif
#endif
                 ! viscosity (along x)
        
                 +halfdt*(vis2d(i+1,j)*forward_dudx(u, i, j) &
                         -vis2d(i,j)*backward_dudx(u, i, j))/dx_u(i,j) 

       ! viscosity and non-linear term
       IF ((hty(i,j-1)+hty(i+1,j-1)) >= 0.0_rsh) THEN
         dudy=backward_dudy(u, i, j)
         
         y2dv(i,j)=y2dv(i,j)                            &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                   ! non-linear (vdu/dy) : explicit part
                   -0.25_rlg*dt*v_utmp*dudy             &
#endif
#endif
                   ! viscosity (along y) : explicit
                   -halfdt*vis2d(i,j-1)*dudy/dy_u(i,j)
       END IF
       IF ((hty(i,j  )+hty(i+1,j  )) >= 0.0_rsh) THEN
         dudy=   forward_dudy(u, i, j)
         y2dv(i,j)=y2dv(i,j)                            &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                   -0.25_rlg*dt*v_utmp*dudy             &
#endif
#endif
                   ! viscosity (along y) : explicit
                   +halfdt*vis2d(i,j)*dudy/dy_u(i,j)
       END IF

       ! wind stress and atmospherical pressure gradient
       y2dv(i,j)=y2dv(i,j)                              &

                 ! wind stress in x-direction : explicit
                 +halfdt*tosx(i,j)/MAX(htx(i,j),hminfrot)/rhoref &

                 ! atmospherical pressure gradient : explicit
                 -halfdt*forward_dpadx(pa, i, j)/rhoref

       ! generator potential : explicit
       IF (l_genpot) &
         y2dv(i,j)=y2dv(i,j)+halfdt*forward_dpotgenedx(potgene, i, j)

       END IF

