       ! rhs : explicit terms
       y2dv_aux(i,j)=                                       &
                 ! time evolution (u at n-1/2)
                  u(i,j)                                 &
                 ! bottom stress (u at n) explicit part
                 !-ft*u(i,j)*cfroe                       &
                 ! coriolis
                 +fu(i,j)*v_utmp                  &
                 ! explicit part of the sea surface pressure gradient
                 -0.5_rlg*alphap*gdt*forward_dxedx(xec, i, j) &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear

                 ! NL advection : u*v*tan(phi)/R (spherical coordinates)
                 +u(i,j)*vs_utmp*tfiusr(i,j)      &

                 ! non-linear (udu/dx) : explicit part
                 -us(i,j)*centered_dudx(u, i, j) &
#endif
#endif
                 ! viscosity (along x)
        
                 +(vis2d(i+1,j)*forward_dudx(u, i, j) &
                         -vis2d(i,j)*backward_dudx(u, i, j))/dx_u(i,j) 

       IF ((htx(i-1,j)+htx(i-1,j+1)) >= 0.0_rsh) THEN
          dvsdx=(vs_u(i,j)-vs_u(i-1,j))/dx_f(i-1,j)
       ELSE IF ((htx(i,j)+htx(i,j+1)) >= 0.0_rsh) THEN
          dvsdx=(vs_u(i+1,j)-vs_u(i,j))/dx_f(i,j)
       END IF

       ! viscosity and non-linear term
       IF ((hty(i,j-1)+hty(i+1,j-1)) >= 0.0_rsh) THEN
         dudy=backward_dudy(u, i, j)
         y2dv_aux(i,j)=y2dv_aux(i,j)                   &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                   ! non-linear (vdu/dy) : explicit part
                   -0.25_rlg*dt*vs_u(i,j)*dudy             &
#ifdef key_lans_turb
                   ! non-linear lans ((u-us)du/dy+(v-vs)dv/dy)
                   -(u(i,j)-us(i,j))*centered_dudx(us, i, j)    &
                   -(v_utmp-vs_u(i,j))*dvsdx      &
#endif
#endif
#endif
                   ! viscosity (along y) : explicit
                   -vis2d(i,j-1)*dudy/dy_u(i,j)
       END IF
       IF ((hty(i,j  )+hty(i+1,j  )) >= 0.0_rsh) THEN
         dudy=forward_dudy(u, i, j)
         y2dv_aux(i,j)=y2dv_aux(i,j)                   &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                   -0.25_rlg*dt*vs_u(i,j)*dudy             &
#ifdef key_lans_turb
                   ! non-linear lans ((u-us)du/dy+(v-vs)dv/dy)
                   -(u(i,j)-us(i,j))*centered_dudx(us, i, j)    &
                   -(v_utmp-vs_u(i,j))*dvsdx      &
#endif
#endif
#endif
                   ! viscosity (along y) : explicit
                   +vis2d(i,j)*dudy/dy_u(i,j)
       END IF

       ! wind stress and atmospherical pressure gradient
       y2dv_aux(i,j)=y2dv_aux(i,j)                      &

                 ! wind stress in x-direction : explicit
                 +tosx(i,j)/MAX(htx(i,j),hminfrot)/rhoref &

                 ! atmospherical pressure gradient : explicit
                 -forward_dpadx(pa, i, j)/rhoref

       ! generator potential : explicit
       IF (l_genpot) &
         y2dv_aux(i,j)=y2dv_aux(i,j)+forward_dpotgenedx(potgene, i, j)

       END IF

