!**************** include dyn3dy_atmforc.h *********************************

   !&E---------------------------------------------------------------------
   !&E                 ***  dyn3dy_atmforc.h  ***
   !&E
   !&E ** Purpose : estimate the trend term relative to the met. forcing
   !&E              (atmospherical pressure gradient and wind stress)
   !&E              for the meridional momentum forcing (2D and 3D equation)
   !&E
   !&E ** Description : explicit
   !&E
   !&E ** Called by : included into dyn3dytlscoef.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Used ij-arrays : pres_dyn_atm,tosy,hzuty,hty,dy_v
   !&E
   !&E ** Modified variables : yz_exp,intz_exp
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  1987-02  (P. Lazure)  Original code
   !&E       !  2007-09  (V. Garnier) homogeneneity of dx dy...
   !&E
   !&E---------------------------------------------------------------------

	grad_pa = forward_dpady(pa, i, j)

   	yz_exp(:,i,j) = yz_exp(:,i,j) - grad_pa/rhoref 

   	intz_exp(i,j) = intz_exp(i,j) - grad_pa/rhoref

#if defined key_siggen || defined key_gencoord
    	! le mieux pour l instant mais il faudra tester un nv hminfrot par petit fond
    	yz_exp(kmax,i,j) = yz_exp(kmax,i,j)+tosy(i,j)/(hzuty(kmax,i,j)*dsigu(kmax))/rhoref
#else
    	yz_exp(kmax,i,j) = yz_exp(kmax,i,j)+tosy(i,j)/MAX(hty(i,j),hminfrot)/rhoref/dsigu(kmax)
#endif

    	intz_exp(i,j)    = intz_exp(i,j)+tosy(i,j)/MAX(hty(i,j),hminfrot)/rhoref
!**************** end include dyn3dy_atmforc ********************
