!************    including dyn3dy_corio.h       ***********************

   !&E---------------------------------------------------------------------
   !&E                 ***  dyn3dy_corio.h  ***
   !&E
   !&E ** Purpose : estimate the trend term relative to the Coriolis
   !&E              parameter for the meridional momentum forcing (3D equation)
   !&E
   !&E ** Description : explicit
   !&E
   !&E ** Called by : included into dyn3dxtlscoef.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Used ij-arrays : uz,fv
   !&E
   !&E ** Modified variables : yz_exp
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  1987-02  (P. Lazure)  Original code
   !&E
   !&E---------------------------------------------------------------------

#if defined key_lans_turb || defined key_leray_turb
   yz_exp(:,i,j)=-fv(i,j)*uzs_v(:,i,j)
#else
   yz_exp(:,i,j)=-fv(i,j)*uz_v(:,i,j)
#endif

!*************    end including dyn3dy_corio.h     ************
