        ! rhs : explicit terms
        y2dv(i,j)=                                       &
                  ! time evolution (v at n)
                  v(i,j)                                 &
                  ! bottom stress (v at n)
                  -ft*v(i,j)*cfroe                       &
                  ! coriolis
                  -fv(i,j)*u_vtmp*halfdt                 &
                  ! explicit part of the sea surface pressure gradient
                  -0.5_rlg*gdt/dy_v(i,j)*alphap*( xec(i,j+1)-xec(i,j) )  &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                  ! NL advection : u*u*tan(phi)/R (spherical coordinates)
                  -halfdt*tfivsr(i,j)*u_vtmp**2          &

                  ! non-linear (vdv/dy) : implicit part
                  -halfdt*v(i,j)*centered_dvdy(v, i, j)  &
#endif
#endif
                  ! viscosity (along y)
                  +halfdt*( vis2d(i,j+1)*(v(i,j+1)-v(i,j))/dy(i,j+1)   &
                           -vis2d(i,j  )*(v(i,j  )-v(i,j-1))/dy(i,j  ) )/dy_v(i,j)

        ! viscosity and non-linear term
        IF ((htx(i-1,j)+htx(i-1,j+1)) >= 0.0_rsh) THEN
          dvdx=(v(i,j)-v(i-1,j))/dx_f(i-1,j)
          y2dv(i,j)=y2dv(i,j)                            &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                    ! non-linear (udv/dx) : explicit part
                    -0.25_rlg*dt*u_vtmp*dvdx             &
#endif
#endif
                    ! viscosity (along x) : explicit
                    -halfdt*vis2d(i-1,j)*dvdx/dx_v(i,j)
        END IF
        IF ((htx(i,j)+htx(i,j+1)) >= 0.0_rsh) THEN
          dvdx=(v(i+1,j)-v(i,j))/dx_f(i,j)
          y2dv(i,j)=y2dv(i,j)                            &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                    ! non-linear (udv/dx) : explicit part
                    -0.25_rlg*dt*u_vtmp*dvdx             &
#endif
#endif
                    ! viscosity (along x) : explicit
                    +halfdt*vis2d(i,j)*dvdx/dx_v(i,j)
        END IF

        ! wind stress and atmospherical pressure gradient
        y2dv(i,j)=y2dv(i,j)                              &

                  ! wind stress in y-direction : explicit
                  +halfdt*tosy(i,j)/MAX(hty(i,j),hminfrot)/rhoref &

                  ! atmospherical pressure gradient : explicit
                  -halfdt*forward_dpady(pa, i, j)/rhoref

        ! generator potential : explicit
        IF (l_genpot) &
          y2dv(i,j)=y2dv(i,j)+halfdt/dy_v(i,j)*(potgene(i,j+1)-potgene(i,j))

        END IF
