        ! rhs : explicit terms
        y2dv_aux(i,j)=                                  &
                  ! time evolution (v at n)
                   v(i,j)                                &
                  ! bottom stress (v at n)
                  !-ft*v(i,j)*cfroe                       &
                  ! coriolis
                  -fv(i,j)*us_v(i,j)                     &
                  ! explicit part of the sea surface pressure gradient
                  -0.5_rlg*alphap*gdt/dy_v(i,j)*( xec(i,j+1)-xec(i,j) )  &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                  ! NL advection : u*u*tan(phi)/R (spherical coordinates)
                  -tfivsr(i,j)*us_v(i,j)**2          		&
!
                  ! non-linear (vdv/dy) : implicit part
                  -vs(i,j)*centered_dvdy(v, i, j)  		&
#endif
#endif
                  ! viscosity (along y)
                  +( vis2d(i,j+1)*(v(i,j+1)-v(i,j))/dy(i,j+1)   &
                           -vis2d(i,j  )*(v(i,j  )-v(i,j-1))/dy(i,j  ) )/dy_v(i,j)

          IF ((hty(i,j-1)+hty(i+1,j-1)) >= 0.0_rsh) THEN
                dusdy=backward_dudy(us_v, i, j)
          ELSE IF ((hty(i,j  )+hty(i+1,j  )) >= 0.0_rsh) THEN
                dusdy=forward_dudy(us_v, i, j)
          END IF
!
        ! viscosity and non-linear term
        IF ((htx(i-1,j)+htx(i-1,j+1)) >= 0.0_rsh) THEN
          dvdx=(v(i,j)-v(i-1,j))/dx_f(i-1,j)
          y2dv_aux(i,j)=y2dv_aux(i,j)                            &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                    ! non-linear (udv/dx) : explicit part
                    -0.25_rlg*dt*us_v(i,j)*dvdx                    &
#ifdef key_lans_turb
                    ! non-linear lans ((u-us)du/dy+(v-vs)dv/dy) 
		    -(u_vtmp-us_v(i,j))*dusdy			   &
                    -(v(i,j)-vs(i,j))*centered_dvdy(vs, i, j)	   &
#endif
#endif
#endif
                    ! viscosity (along x) : explicit
                    -vis2d(i-1,j)*dvdx/dx_v(i,j)
        END IF
        IF ((htx(i,j)+htx(i,j+1)) >= 0.0_rsh) THEN
          dvdx=(v(i+1,j)-v(i,j))/dx_f(i,j)
          y2dv_aux(i,j)=y2dv_aux(i,j)                            &
#if ! defined key_dyn_adv_none
#if ! defined key_dyn_adv_linear
                    ! non-linear (udv/dx) : explicit part
                    -0.25_rlg*dt*us_v(i,j)*dvdx             	   &
#ifdef key_lans_turb
                    ! non-linear lans ((u-us)du/dy+(v-vs)dv/dy)
                    -(u_vtmp-us_v(i,j))*dusdy                      &
                    -(v(i,j)-vs(i,j))*centered_dvdy(vs, i, j)      &
#endif
#endif
#endif
                    ! viscosity (along x) : explicit
                    +vis2d(i,j)*dvdx/dx_v(i,j)
        END IF

        ! wind stress and atmospherical pressure gradient
        y2dv_aux(i,j)=y2dv_aux(i,j)                              &
                  ! wind stress in y-direction : explicit
                  +tosy(i,j)/MAX(hty(i,j),hminfrot)/rhoref &

                  ! atmospherical pressure gradient : explicit
                  -forward_dpady(pa, i, j)/rhoref

        ! generator potential : explicit
        IF (l_genpot) &
          y2dv_aux(i,j)=y2dv_aux(i,j)+forward_dpotgenedy(potgene, i, j)
        END IF
