   !-----------------------------------------------------------------------

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE palmww3  ***
   !&E
   !&E ** Purpose : coupling with WW3
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by : step.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Reference :
   !&E
   !&E ** History : 2103-08 (A-C. Bennis and F. Dumas) - creation
   !&E
   !&E---------------------------------------------------------------------

   IF (nbouc==1) timea_start=0
   IF (nbouc==1) timeb_start=0

   IF (t.ge.tdeb) THEN

     IF (timea_start.eq.0) THEN
       timea_nbouc=nbouc
       timeb_nbouc=timea_nbouc+5
       timea_start=timea_nbouc
       timeb_start=timeb_nbouc
       timea=1
     END IF

     PRINT_DBG_WAVE*,'pt0: nbouc,timea_nbouc,timea',nbouc,timea_nbouc,timea

     IF (nbouc.eq.timea_nbouc) THEN
       IF ((timea.ge.min_palm_time_a).and.(timea.le.max_palm_time_a)) THEN

         PRINT_DBG_WAVE*,'pt1: nbouc,timea_nbouc,timea',nbouc,timea_nbouc,timea

   !! envoi de la composante en x du courant barotrope a mtw
!
         cl_space  = 'mat2d'
         cl_object = 'matricedistu'
         usend=u(:,ljmin:ljmax)
         CALL PALM_Put(cl_space, cl_object, timea, PL_NO_TAG, usend,   il_err)

   !! envoi de la composante en y du courant barotrope a mtw
!
         cl_space  = 'mat2d'
         cl_object = 'matricedistv'
         usend=v(:,ljmin:ljmax)
         CALL PALM_Put(cl_space, cl_object, timea, PL_NO_TAG, usend,   il_err)

   !! envoi de elevation de la surface a mtw
!
         cl_space  = 'mat2d'
         cl_object = 'matricedistxe'
         usend=ssh(:,ljmin:ljmax)
         CALL PALM_Put(cl_space, cl_object, timea, PL_NO_TAG, usend,   il_err)
!
         timea=timea+1
         timea_nbouc=timea_nbouc+4
       END IF
     END IF

     IF (nbouc.eq.timeb_start) timeb=1
     PRINT_DBG_WAVE*,'pt2: nbouc,timea_nbouc,timea',nbouc,timea_nbouc,timea
     PRINT_DBG_WAVE*,'pt3: nbouc,timeb_nbouc,timeb',nbouc,timeb_nbouc,timeb

     IF (nbouc.eq.timeb_nbouc) THEN
       IF ((timeb.ge.min_palm_time_b).and.(timeb.le.max_palm_time_b)) THEN

         PRINT_DBG_WAVE*,'pt4: nbouc,timeb_nbouc,timeb',nbouc,timeb_nbouc,timeb

   !! envoi des niveaux sigma a wwtomars.f90
         cl_space = 'vect1dmars'
         cl_object = 'vectmars'
         usendsig=sig(1:kmax)
         CALL PALM_Put(cl_space, cl_object, timeb, PL_NO_TAG, usendsig, il_err)

   !! envoi de elevation de la surface a wwtomars.f90

         cl_space  = 'mat2d'
         cl_object = 'matricexem'
         usendxe=ssh(:,ljmin:ljmax)
         CALL PALM_Put(cl_space, cl_object, timeb, PL_NO_TAG, usend,   il_err)

   !! reception de la composante en x de la derive de stokes de wwtomars.f90

!ACB USXm dans wwtomars.f90
         cl_space  = 'mat3d'
         cl_object = 'USX'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, USX,il_err)

   !! reception de la composante en y de la derive de stokes de wwtomars.f90

!ACB USYm dans wwtomars.f90
         cl_space  = 'mat3d'
         cl_object = 'USY'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, USY,il_err)

   !! reception de la composante en z de la derive de stokes de wwtomars.f90

!ACB USZm dans wwtomars.f90
         cl_space  = 'mat3d'
         cl_object = 'USZ'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, USZ,il_err)

   !! reception de la composante en x de la somme des termes suivants :
   !! -1*(gradient de la pression induite par les vagues)
   !! + repartition sur la verticale de tauox (eastward wave to ocean stress)
!
         cl_space  = 'mat3d'
         cl_object = 'smb1xm'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, smb1xm,il_err)

   !! reception de la composante en y de la somme des termes suivants :
   !! -1*(gradient de la pression induite par les vagues)
   !! + repartition sur la verticale de tauoy (northward wave to ocean stress)
!
         cl_space  = 'mat3d'
         cl_object = 'smb1ym'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, smb1ym,il_err)

   !! reception de la norme de la vitesse orbitale pres du fond de wwtomars.f90
!
         cl_space  = 'mat2d'
         cl_object = 'uorb'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, uorb,il_err)

   !! reception de la moyenne quadratique de la hauteur
   !! significative des vagues de wwtomars.f90

!ACB hrmsmars dans wwtomars.f90
         cl_space  = 'mat2d'
         cl_object = 'hrms'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, hrms,il_err)

   !! reception de : wave to ocean energy flux

!ACB tauoxym dans wwtomars.f90
         cl_space  = 'mat2d'
         cl_object = 'wave_phioc'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, wave_phioc,il_err)

   !! reception de l elevation calculee pour un cas stationnaire
   !! utilise en obc (-J/g)

!ACB non pris en compte dans le code MARS
        cl_space  = 'mat2d'
   	cl_object = 'elevs'
	CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, elevs,il_err)

   !! reception de la frequence intriseque des vagues de wwtomars.f90

!ACB iwf dans wwtomars.f90
         cl_space  = 'mat2d'
         cl_object = 'wave_freq'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, wave_freq,il_err)

   !! reception du nombre d onde de wwtomars.f90

!ACB iwn dans wwtomars.f90
        cl_space  = 'mat2d'
   	cl_object = 'wave_number'
	CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, wave_number,il_err)

   !! reception de la direction moyenne des vagues de wwtomars.f90

!ACB ith dans wwtomars.f90
        cl_space  = 'mat2d'
   	cl_object = 'THETA'
   	CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, THETA,il_err)

   !! reception de : eastward wave supported wind stress

         cl_space  = 'mat2d'
         cl_object = 'tauwix'
! ACB elimine car doublon, devenu tauwx
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, tauwix,il_err)

   !! reception de : northward wave supported wind stress

         cl_space  = 'mat2d'
         cl_object = 'tauwiy'
! ACB elimine car doublon, devenu tauwy
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, tauwiy,il_err)

   !! reception de : eastward wave to ocean stress

!ACB twox dans wwtomars.f90
         cl_space  = 'mat2d'
         cl_object = 'tauox'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, tauox,il_err)

   !! reception de : northward wave to ocean stress

!ACB twoy dans wwtomars.f90
         cl_space  = 'mat2d'
         cl_object = 'tauoy'
         CALL PALM_get(cl_space, cl_object, timeb, PL_NO_TAG, tauoy,il_err)
       END IF
       timeb=timeb+1
       timeb_nbouc=timeb_nbouc+4
     END IF
   END IF

   PRINT_DBG_WAVE*,'pt5: nbouc,timeb_nbouc,timeb',nbouc,timeb_nbouc,timeb
