!----------------------------------------------------------------
!!COMPUTE THE GRADIENT USING THE BACKWARD DIFFERENCE (FIRST ORDER)
!----------------------------------------------------------------

!x-direction
        !2d variable

        !2d variable
        FUNCTION backward_dudx(u, i, j) RESULT(dudx)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2),INTENT(IN) :: u
                 INTEGER,        INTENT(IN) :: i, j

                 !Output parameter
                 REAL(kind=rsh) :: dudx

                 dudx = (u(i,j)-u(i-1,j))/dx(i,j)

        END FUNCTION backward_dudx


       !3d variable
        FUNCTION backward_duzdx(uz, i, j) RESULT(duzdx)

                IMPLICIT NONE

                !Inpout parameter
                REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2, ljminm2:ljmaxp2), INTENT(IN) :: uz
                INTEGER,        INTENT(IN) :: i, j

                !Output parameter
                REAL(kind=rsh), DIMENSION(kmax) :: duzdx

                duzdx(:) = (uz(:,i,j)-uz(:,i-1,j))/dx(i,j)

        END FUNCTION backward_duzdx 

!y-direction
        !2d variable

        FUNCTION backward_dudy(u, i, j) RESULT(dudy)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2),INTENT(IN) :: u
                 INTEGER,        INTENT(IN) :: i, j

                 !Output parameter
                 REAL(kind=rsh) :: dudy

                 dudy = (u(i,j)-u(i,j-1))/dy_f(i,j-1)

        END FUNCTION   backward_dudy

        !3d variable
        FUNCTION backward_duzdy(uz, i, j) RESULT(duzdy)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2, ljminm2:ljmaxp2), INTENT(IN) :: uz
                 INTEGER,        INTENT(IN) :: i, j

                 !Output parameter
                 REAL(kind=rsh), DIMENSION(kmax) :: duzdy

                 duzdy(:) = (uz(:,i,j)-uz(:,i,j-1))/dy_f(i,j-1)

        END FUNCTION  backward_duzdy

!z-direction
        FUNCTION backward_derivative_zdir(phi, dsig, k, i, j) RESULT(phi_deriv)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2, ljminm2:ljmaxp2), INTENT(IN) :: phi
                 REAL(KIND=rsh), INTENT(IN) :: dsig
                 INTEGER,        INTENT(IN) :: k, i, j

                 !Output parameter
                 REAL(kind=rsh) :: phi_deriv

                 phi_deriv = (phi(k,i,j)-phi(k-1,i,j))/dsig

        END FUNCTION  backward_derivative_zdir
