MODULE bottom_stress

   !!======================================================================
   !!                   ***  MODULE interpolation_methods  ***
   !!
   !! ** Description :

   !!      !!======================================================================
   !! * Modules used
   USE parameters          !

   IMPLICIT NONE

   PUBLIC:: drag_coef, drag_times_vit 
   
   CONTAINS
!---------------------------
!DRAG COEFFICIENT
!---------------------------
        FUNCTION drag_coef(ht, sig1, z0) RESULT(cd)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), INTENT(IN) :: ht, sig1, z0

                 !Output parameter
                 REAL(kind=rsh) :: cd

                 cd = (0.4_rsh/LOG((sig1+1.0_rsh)*ht/z0 + 1.0_rsh))**2

        END FUNCTION drag_coef

!-----------------------------
!DRAG TIMES VELOCITY MAGNITUDE 
!-----------------------------

        FUNCTION drag_times_vit(uzb, vzb, cd) RESULT(cdvit)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), INTENT(IN) :: uzb, vzb, cd

                 !Output parameter
                 REAL(kind=rsh) :: cdvit

                !Local declaration
                REAL(kind=rsh) ::  norm_velb

                norm_velb = SQRT(vzb*vzb+ uzb*uzb)

                cdvit = cd*norm_velb

        END FUNCTION drag_times_vit

END MODULE bottom_stress
