!---------------------
!LANS NON LINEAR TERMS
!---------------------

        FUNCTION lans_nl_centered_lon(uz, uzs, vz_u, vzs_u, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz, uzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz_u, vzs_u

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: udusdx, vdvsdx

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !u * dus/dx
                 udusdx  = (uz(k,i,j)-uzs(k,i,j))*centered_duzdx(uzs, k, i, j)

                 !v * dvs/dx
                 vdvsdx  = (vz_u(k,i,j)-vzs_u(k,i,j))*centered_dvzdx(vzs_u, k, i, j)

                 lans_nl = udusdx + vdvsdx

        END FUNCTION lans_nl_centered_lon

        FUNCTION lans_nl_centered_lat(uz_v, uzs_v, vz, vzs, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz, vzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz_v, uzs_v

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: vdvsdy, udusdy

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !v * dvs/dy
                 vdvsdy   = (vz(k,i,j)-vzs(k,i,j))*centered_dvzdy(vzs, k, i, j)

                 !u * dus/dy
                 udusdy   = (uz_v(k,i,j)-uzs_v(k,i,j))*centered_duzdy(uzs_v, k, i, j)

                 lans_nl  = vdvsdy + udusdy

        END FUNCTION lans_nl_centered_lat
