!---------------------
!LANS NON LINEAR TERMS
!---------------------

        FUNCTION calc_dzdx(xe, k, i, j) RESULT (dzdx)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: xe
        	 INTEGER, INTENT(IN) :: k, i, j

                 !Output parameter
                 REAL(kind=rsh) :: dzdx

                 dzdx = (f_zw_x(hx(i,j),xe(i,j),k,i,j)- f_zw_x(hx(i-1,j),xe(i-1,j),k,i-1,j))/dx_u(i,j)

        END FUNCTION

        FUNCTION calc_dzdy(xe, k, i, j) RESULT (dzdy)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: xe
                 INTEGER, INTENT(IN) :: k, i, j

                 !Output parameter
                 REAL(kind=rsh) :: dzdy

                 dzdy = (f_zw_y(hy(i,j),xe(i,j),k,i,j)- f_zw_y(hy(i,j-1),xe(i,j-1),k,i,j-1))/dy_v(i,j) 

        END FUNCTION

        FUNCTION lans_nl_quick_lon(uz, uzs, vz_u, vzs_u, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz, uzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz_u, vzs_u

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: vel_adv, udusdx, vdvsdx

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !u * dus/dx
                 vel_adv = uz(k,i,j) - uzs(k,i,j) 
                 udusdx  = vel_adv*quick_duzdx(uzs, vel_adv, k, i, j)

                 !v * dvs/dx
                 vel_adv = vz_u(k,i,j) - vzs_u(k,i,j)
                 vdvsdx  = vel_adv*quick_dvzdx(vzs_u, vel_adv, k, i, j)

                 lans_nl = udusdx + vdvsdx

        END FUNCTION lans_nl_quick_lon

        FUNCTION lans_nl_sig_quick_lon(uz, uzs, vz_u, vzs_u, dzdx, xe, i, j) RESULT(lans_nl_sig)

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz, uzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz_u, vzs_u

                 REAL(KIND=rsh), DIMENSION(kmax,limin:limax,ljmin:ljmax), INTENT(IN) :: dzdx

                 REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: xe

                 INTEGER, INTENT(IN) :: i, j

                 !Output parameter
                 REAL(KIND=rsh), DIMENSION(kmax) :: lans_nl_sig

		 !local declaration
                 INTEGER :: k

   		 REAL(KIND=rsh) :: d, vel_adv, udusdsig, vdvsdsig, usdudsig, vsdvdsig

                 d = hx(i,j) + xe(i,j) 

		 !at the first bottom cell
		 k=1
                 udusdsig = (uz(k,i,j)-uzs(k,i,j))*(uzs(k+1,i,j)-uzs(k,i,j))/dsigw(k)
                 vdvsdsig = (vz_u(k,i,j)-vzs_u(k,i,j))*(vzs_u(k+1,i,j)-vzs_u(k,i,j))/dsigw(k)

		 lans_nl_sig(k) = dzdx(k,i,j)*(udusdsig+vdvsdsig)/d

                 k=2
                 vel_adv  = uz(k,i,j)-uzs(k,i,j)
                 udusdsig = vel_adv*upwind_duzdz(uzs, vel_adv, dsigw(k-1), dsigw(k), k, i, j)
                 vel_adv  = vz_u(k,i,j)-vzs_u(k,i,j)
                 vdvsdsig = vel_adv*upwind_dvzdz(vzs_u, vel_adv, dsigw(k-1), dsigw(k), k, i, j)

                 lans_nl_sig(k) = dzdx(k,i,j)*(udusdsig+vdvsdsig)/d

  		 DO k=3,kmax-2
                 	vel_adv  = uz(k,i,j)-uzs(k,i,j)
                 	udusdsig = vel_adv*quick_duzdz(uzs, vel_adv, dsigw(k), k, i, j)
                 	vel_adv  = vz_u(k,i,j)-vzs_u(k,i,j)
                 	vdvsdsig = vel_adv*quick_dvzdz(vzs_u, vel_adv, dsigw(k), k, i, j)

                 	lans_nl_sig(k) = dzdx(k,i,j)*(udusdsig+vdvsdsig)/d
		 END DO

                 k=kmax-1
     		 vel_adv  = uz(k,i,j)-uzs(k,i,j)
     		 udusdsig = vel_adv*upwind_duzdz(uzs, vel_adv, dsigw(k-1), dsigw(k), k, i, j)
                 vel_adv  = vz_u(k,i,j)-vzs_u(k,i,j)
                 vdvsdsig = vel_adv*upwind_dvzdz(vzs_u, vel_adv, dsigw(k-1), dsigw(k), k, i, j)

                 lans_nl_sig(k) = dzdx(k,i,j)*(udusdsig+vdvsdsig)/d

		 k=kmax
                 udusdsig = (uz(k,i,j)-uzs(k,i,j))*(uzs(k,i,j)-uzs(k-1,i,j))/dsigw(k-1)
                 vdvsdsig = (vz_u(k,i,j)-vzs_u(k,i,j))*(vzs_u(k,i,j)-vzs_u(k-1,i,j))/dsigw(k-1)

                 lans_nl_sig(k) = dzdx(k,i,j)*(udusdsig+vdvsdsig)/d

        END FUNCTION lans_nl_sig_quick_lon

        FUNCTION lans_nl_quick_lat(uz_v, uzs_v, vz, vzs, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz, vzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz_v, uzs_v

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: vel_adv, vdvsdy, udusdy

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !v * dvs/dy
                 vel_adv = vz(k,i,j) - vzs(k,i,j)
                 vdvsdy  = vel_adv*quick_dvzdy(vzs, vel_adv, k, i, j)

                 !u * dus/dy
                 vel_adv = uz_v(k,i,j) - uzs_v(k,i,j)
                 udusdy  = vel_adv*quick_duzdy(uzs_v, vel_adv, k, i, j)

                 lans_nl = vdvsdy + udusdy

        END FUNCTION lans_nl_quick_lat

        FUNCTION lans_nl_sig_quick_lat(uz_v, uzs_v, vz, vzs, dzdy, xe, i, j) RESULT(lans_nl_sig)

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz_v, uzs_v

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz, vzs

                 REAL(KIND=rsh), DIMENSION(kmax,limin:limax,ljmin:ljmax), INTENT(IN) :: dzdy

                 REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: xe

                 INTEGER, INTENT(IN) :: i, j

                 !Output parameter
                 REAL(KIND=rsh), DIMENSION(kmax) :: lans_nl_sig

                 !local declaration
                 INTEGER :: k

                 REAL(KIND=rsh) :: d, vel_adv, udusdsig, vdvsdsig, usdudsig, vsdvdsig

                 d = hy(i,j) + xe(i,j) 

		 !at the first bottom cell
                 k=1
                 udusdsig = (uz_v(k,i,j)-uzs_v(k,i,j))*(uzs_v(k+1,i,j)-uzs_v(k,i,j))/dsigw(k)
                 vdvsdsig = (vz(k,i,j)-vzs(k,i,j))*(vzs(k+1,i,j)-vzs(k,i,j))/dsigw(k)

                 lans_nl_sig(k) = dzdy(k,i,j)*(udusdsig+vdvsdsig)/d

                 k=2
                 vel_adv  = uz_v(k,i,j)-uzs_v(k,i,j)
                 udusdsig = vel_adv*upwind_duzdz(uzs_v, vel_adv, dsigw(k-1), dsigw(k), k, i, j)
                 vel_adv  = vz(k,i,j)-vzs(k,i,j)
                 vdvsdsig = vel_adv*upwind_dvzdz(vzs, vel_adv, dsigw(k-1), dsigw(k), k, i, j)

                 lans_nl_sig(k) = dzdy(k,i,j)*(udusdsig+vdvsdsig)/d

                 DO k=3,kmax-2
                        vel_adv  = uz_v(k,i,j)-uzs_v(k,i,j)
                        udusdsig = vel_adv*quick_duzdz(uzs_v, vel_adv, dsigw(k), k, i, j)
                        vel_adv  = vz(k,i,j)-vzs(k,i,j)
                        vdvsdsig = vel_adv*quick_dvzdz(vzs, vel_adv, dsigw(k), k, i, j)

                        lans_nl_sig(k) = dzdy(k,i,j)*(udusdsig+vdvsdsig)/d
                 END DO

                 k=kmax-1
                 vel_adv  = uz_v(k,i,j)-uzs_v(k,i,j)
                 udusdsig = vel_adv*upwind_duzdz(uzs_v, vel_adv, dsigw(k-1), dsigw(k), k, i, j)
                 vel_adv  = vz(k,i,j)-vzs(k,i,j)
                 vdvsdsig = vel_adv*upwind_dvzdz(vzs, vel_adv, dsigw(k-1), dsigw(k), k, i, j)

                 lans_nl_sig(k) = dzdy(k,i,j)*(udusdsig+vdvsdsig)/d

                 k=kmax
                 udusdsig = (uz_v(k,i,j)-uzs_v(k,i,j))*(uzs_v(k,i,j)-uzs_v(k-1,i,j))/dsigw(k-1)
                 vdvsdsig = (vz(k,i,j)-vzs(k,i,j))*(vzs(k,i,j)-vzs(k-1,i,j))/dsigw(k-1)

                 lans_nl_sig(k) = dzdy(k,i,j)*(udusdsig+vdvsdsig)/d

       END FUNCTION lans_nl_sig_quick_lat
