!---------------------
!LANS NON LINEAR TERMS
!---------------------

        FUNCTION lans_nl_quickest_lon(uz, uzs, vz_u, vzs_u, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz, uzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz_u, vzs_u

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: vel_adv, udusdx, vdvsdx, usdudx, vsdvdx

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !u * dus/dx
                 vel_adv = uz(k,i,j)
                 udusdx  = vel_adv*quickest_duzdx(uzs, vel_adv, k, i, j)

                 !v * dvs/dx
                 vel_adv = vz_u(k,i,j)
                 vdvsdx  = vel_adv*quickest_dvzdx(vzs_u, vel_adv, k, i, j)

                 !us * du/dx
                 vel_adv = uzs(k,i,j)
                 usdudx  = vel_adv*quickest_duzdx(uz, vel_adv, k, i, j)

                 !vs * dv/dx
                 vel_adv = vzs_u(k,i,j)
                 vsdvdx  = vel_adv*quickest_dvzdx(vz_u, vel_adv, k, i, j)

                 lans_nl = 0.5*(udusdx + vdvsdx - usdudx - vsdvdx)

        END FUNCTION lans_nl_quickest_lon

       FUNCTION lans_nl_quickest_lat(uz_v, uzs_v, vz, vzs, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz, vzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz_v, uzs_v

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: vel_adv, vdvsdy, udusdy, vsdvdy, usdudy 

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !v * dvs/dy
                 vel_adv  = vz(k,i,j)
                 vdvsdy   = vel_adv*quickest_dvzdy(vzs, vel_adv, k, i, j)

                 !u * dus/dy
                 vel_adv  = uz_v(k,i,j)
                 udusdy   = vel_adv*quickest_duzdy(uzs_v, vel_adv, k, i, j)

                 !vs * dv/dy
                 vel_adv  = vzs(k,i,j)
                 vsdvdy   = vel_adv*quickest_dvzdy(vz, vel_adv, k, i, j)

                 !us * du/dy
                 vel_adv  = uzs_v(k,i,j)
                 usdudy   = vel_adv*quickest_duzdy(uz_v, vel_adv, k, i, j)

                 lans_nl  = 0.5*(vdvsdy + udusdy - vdvsdy - udusdy)

        END FUNCTION lans_nl_quickest_lat
