        FUNCTION lans_nl_upwind_longi(uz, uzs, vz_u, vzs_u, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz, uzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz_u, vzs_u

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: vel_adv, udusdx, vdvsdx

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !u * dus/dx
                 vel_adv = uz(k,i,j) - uzs(k,i,j)

                 udusdx  = vel_adv*upwind_duzdx(uzs, vel_adv, k, i, j)

                 !v * dvs/dx
                 vel_adv = vz_u(k,i,j)-vzs_u(k,i,j)

                 vdvsdx  = vel_adv*upwind_dvzdx(vzs_u, vel_adv, k, i, j)

                 lans_nl = udusdx + vdvsdx 

        END FUNCTION lans_nl_upwind_longi

        FUNCTION lans_nl_upwind_lati(uz_v, uzs_v, vz, vzs, k, i, j) RESULT(lans_nl)

                 IMPLICIT NONE

                 !Inpout parameter
                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: vz, vzs

                 REAL(KIND=rsh), DIMENSION(kmax,liminm2:limaxp2,ljminm2:ljmaxp2), INTENT(IN) :: uz_v, uzs_v

                 INTEGER, INTENT(IN) :: k, i, j

                 !Local declaration
                 REAL(kind=rsh) :: vel_adv, vdvsdy, udusdy

                 !Output parameter
                 REAL(kind=rsh) :: lans_nl

                 !v * dvs/dy
                 vel_adv  = vz(k,i,j) - vzs(k,i,j)
                 vdvsdy   = vel_adv*upwind_dvzdy(vzs, vel_adv, k, i, j)

                 !u * dus/dy
                 vel_adv  = uz_v(k,i,j) - uzs_v(k,i,j)
                 udusdy   = vel_adv*upwind_duzdy(uzs_v, vel_adv, k, i, j)

                 lans_nl  = vdvsdy + udusdy

        END FUNCTION lans_nl_upwind_lati
