FUNCTION laplacian_u(u, i, j) RESULT(lp_u)

                IMPLICIT NONE

                !Inpout parameter
                REAL(KIND=rsh), DIMENSION(liminm2:limaxp2, ljminm2:ljmaxp2), INTENT(IN) :: u

                INTEGER, INTENT(IN) :: i, j

                !Output parameter
                REAL(kind=rsh) :: lp_u

                !Local declaration
                REAL(kind=rsh) :: dudx, dudy

                dudx = ((u(i+1,j)-u(i,j))/dx(i+1,j)    &
                        -(u(i,j)-u(i-1,j))/dx(i,j))/dx_u(i,j)

                dudy = (mn(i,j)*(u(i,j+1)-u(i,j))/dy_f(i,j) &
                       *ms(i,j)*(u(i,j  )-u(i,j-1))/dy_f(i,j-1))/dy_u(i,j)

                lp_u = dudx + dudy

END FUNCTION laplacian_u

FUNCTION laplacian_v(v, i, j) RESULT(lp_v)

                IMPLICIT NONE

                !Inpout parameter

                REAL(KIND=rsh), DIMENSION(liminm2:limaxp2, ljminm2:ljmaxp2), INTENT(IN) :: v

                INTEGER,        INTENT(IN) :: i, j

                !Output parameter
                REAL(kind=rsh)  :: lp_v

                !Local declaration
                REAL(kind=rsh) :: dvdx, dvdy

                dvdx = (me(i,j)*(v(i+1,j)-v(i,j))/dx_f(i,j)                  &
                          -mo(i,j)*(v(i,j)-v(i-1,j))/dx_f(i-1,j))/dx_v(i,j)

                dvdy = ((v(i,j+1)-v(i,j  ))/dy(i,j+1)         &
                        -(v(i,j)-v(i,j-1))/dy(i,j))/dy_v(i,j)

                lp_v = dvdx + dvdy

END FUNCTION laplacian_v

