!********************************************************************
!     
      subroutine obcch3_produit_scalaire(vout,v1,v2)
!     
!********************************************************************
!     
!     objet    : calcul du produit scalaire entre deux vecteurs
!                propres ...
!                
!
!     appelant         : cal_coef 
!                      :
!     appeles          : 
!     canal d ecriture :
!     canal de lecture :
!     cle cpp          : 
!                      :
!     variables in     : 
!                      :
!     variables out    : 
!                      :
!     variables inout  :  
!
!***********************************************************

!!
!! Arguments : 
!! Variable en sortie (projection) : vout
!! Variable a projeter             : VR
!! Numero du premier mode pour la projection :  i
!! Numero du deuxieme mode pour la projection : j
!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
!  
use comvars3d
use comvars2d
use comcfo
implicit none
!
!! declaration programme
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	

      integer                            :: k
      real(kind=rsh),dimension(1:kmax),intent(in)   :: v1,v2
      real(kind=rlg),intent(out)         :: vout
      real(kind=rlg)                     :: prec,cour
      
!
! I. Produit scalaire de la variable v1 avec le mode jp
!    en un point de la frontiere, on nglige l elevation
!    de la surface d eau par rapport a la hauteur d eau totale
!    d ou la formule ci dessous
!

   print*,'STILL WITH 0<sig<1'
   print*,'The simulation is stopped'
   stop
!-------------------------------------------      
! Attention : formule des rectangles
!-------------------------------------------

#ifdef debug_obcch3_produit_scalaire 
   write(*,*) 'v1',v1
   write(*,*) 'v2',v2
#endif
 
      vout=0.0
      do k=1,kmax
          vout=vout+dble(v1(k))*v2(k)*dsigu(k)
      enddo
      
#ifdef debug_obcch3_produit_scalaire   
   write(*,*) '<v1,v2>',vout
#endif      
!-------------------------------------------      
! Attention : formule des trapezes a ne pas utiliser car ne preserve pas 
!             l orthogonalite des modes ...
!-------------------------------------------
!
!      vout=0.0
!      prec=v1(kmax)*v2(kmax)
!      vout=vout+prec*(1-sig(kmax))
!      do k=kmax-1,1,-1
!	 cour=v1(k)*v2(k)
!         vout=vout+0.5*(prec+cour)*dsigw(k)
!	 prec=cour
!      enddo
!      vout=vout+v1(1)*v2(1)*sig(1)

end subroutine obcch3_produit_scalaire
