MODULE smooth_fw9
#if defined key_lans_turb || defined key_leray_turb

    USE parameters
    USE comvars2d
    USE comcolig2d
    USE smooth_fw7

    IMPLICIT NONE

    CONTAINS

    FUNCTION calc_smooth_vel_fw9(vel, w, sum_w, i, j) RESULT(vel_smooth)

         IMPLICIT NONE

         !Inpout parameter
         REAL(KIND=rsh), DIMENSION(liminm4:limaxp4,ljminm4:ljmaxp4), INTENT(IN) :: vel

         REAL(KIND=rsh), DIMENSION(1:9,1:9), INTENT(IN) :: w

         REAL(KIND=rsh), INTENT(IN) :: sum_w

         INTEGER, INTENT(IN) :: i, j

         !Output parameter
         REAL(kind=rsh) :: vel_smooth

         vel_smooth = (w(1,1)*vel(i-4,j-4) + w(1,2)*vel(i-3,j-4) + w(1,3)*vel(i-2,j-4) + w(1,4)*vel(i-1,j-4) + w(1,5)*vel(i,j-4) + w(1,6)*vel(i+1,j-4) + w(1,7)*vel(i+2,j-4) + &
                       w(1,8)*vel(i+3,j-4) + w(1,9)*vel(i+4,j-4) + &
                       w(2,1)*vel(i-4,j-3) + w(2,2)*vel(i-3,j-3) + w(2,3)*vel(i-2,j-3) + w(2,4)*vel(i-1,j-3) + w(2,5)*vel(i,j-3) + w(2,6)*vel(i+1,j-3) + w(2,7)*vel(i+2,j-3) + &
                       w(2,8)*vel(i+3,j-3) + w(2,9)*vel(i+4,j-3) + &
                       w(3,1)*vel(i-4,j-2) + w(3,2)*vel(i-3,j-2) + w(3,3)*vel(i-2,j-2) + w(3,4)*vel(i-1,j-2) + w(3,5)*vel(i,j-2) + w(3,6)*vel(i+1,j-2) + w(3,7)*vel(i+2,j-2) + &
                       w(3,8)*vel(i+3,j-2) + w(3,9)*vel(i+4,j-2) + &
                       w(4,1)*vel(i-4,j-1) + w(4,2)*vel(i-3,j-1) + w(4,3)*vel(i-2,j-1) + w(4,4)*vel(i-1,j-1) + w(4,5)*vel(i,j-1) + w(4,6)*vel(i+1,j-1) + w(4,7)*vel(i+2,j-1) + &
                       w(4,8)*vel(i+3,j-1) + w(4,9)*vel(i+4,j-1) + &
                       w(5,1)*vel(i-4,j)   + w(5,2)*vel(i-3,j)   + w(5,3)*vel(i-2,j)   + w(5,4)*vel(i-1,j)   + w(5,5)*vel(i,j)   + w(5,6)*vel(i+1,j)   + w(5,7)*vel(i+2,j)   + &
                       w(5,8)*vel(i+3,j)   + w(5,9)*vel(i+4,j)   + &
                       w(6,1)*vel(i-4,j+1) + w(6,2)*vel(i-3,j+1) + w(6,3)*vel(i-2,j+1) + w(6,4)*vel(i-1,j+1) + w(6,5)*vel(i,j+1) + w(6,6)*vel(i+1,j+1) + w(6,7)*vel(i+2,j+1) + &
                       w(6,8)*vel(i+3,j+1) + w(6,9)*vel(i+4,j+1) + &
                       w(7,1)*vel(i-4,j+2) + w(7,2)*vel(i-3,j+2) + w(7,3)*vel(i-2,j+2) + w(7,4)*vel(i-1,j+2) + w(7,5)*vel(i,j+2) + w(7,6)*vel(i+1,j+2) + w(7,7)*vel(i+2,j+2) + &
                       w(7,8)*vel(i+3,j+2) + w(7,9)*vel(i+4,j+2) + &
                       w(8,1)*vel(i-4,j+3) + w(8,2)*vel(i-3,j+3) + w(8,3)*vel(i-2,j+3) + w(8,4)*vel(i-1,j+3) + w(8,5)*vel(i,j+3) + w(8,6)*vel(i+1,j+3) + w(8,7)*vel(i+2,j+3) + &
                       w(8,8)*vel(i+3,j+3) + w(8,9)*vel(i+4,j+3) + &
                       w(9,1)*vel(i-4,j+4) + w(9,2)*vel(i-3,j+4) + w(9,3)*vel(i-2,j+4) + w(9,4)*vel(i-1,j+4) + w(9,5)*vel(i,j+4) + w(9,6)*vel(i+1,j+4) + w(9,7)*vel(i+2,j+4) + &
                       w(9,8)*vel(i+3,j+4) + w(9,9)*vel(i+4,j+4)   &
                      )/sum_w

!!!         IF (i==349 .AND. j==349) THEN
!!!!         IF (i==6 .AND. j==200) THEN
!!!                WRITE(*,*)"u=",vel(i,j)
!!!                WRITE(*,*)"us=",vel_smooth
!!!         END IF

    END FUNCTION calc_smooth_vel_fw9 

    FUNCTION calc_smooth_y2dv_fw9(y2dv, w, sum_w, i, j) RESULT(y2dvs)

         IMPLICIT NONE

         !Inpout parameter
         REAL(KIND=rlg), DIMENSION(liminm4:limaxp4,ljminm4:ljmaxp4), INTENT(IN) :: y2dv


         REAL(KIND=rsh), DIMENSION(1:9,1:9), INTENT(IN) :: w

         REAL(KIND=rsh), INTENT(IN) :: sum_w

         INTEGER, INTENT(IN) :: i, j

         !Output parameter
         REAL(kind=rsh) :: y2dvs

         y2dvs = (w(1,1)*y2dv(i-4,j-4) + w(1,2)*y2dv(i-3,j-4) + w(1,3)*y2dv(i-2,j-4) + w(1,4)*y2dv(i-1,j-4) + w(1,5)*y2dv(i,j-4) + w(1,6)*y2dv(i+1,j-4) + w(1,7)*y2dv(i+2,j-4) + &
                  w(1,8)*y2dv(i+3,j-4) + w(1,9)*y2dv(i+4,j-4) + &
                  w(2,1)*y2dv(i-4,j-3) + w(2,2)*y2dv(i-3,j-3) + w(2,3)*y2dv(i-2,j-3) + w(2,4)*y2dv(i-1,j-3) + w(2,5)*y2dv(i,j-3) + w(2,6)*y2dv(i+1,j-3) + w(2,7)*y2dv(i+2,j-3) + &
                  w(2,8)*y2dv(i+3,j-3) + w(2,9)*y2dv(i+4,j-3) + &
                  w(3,1)*y2dv(i-4,j-2) + w(3,2)*y2dv(i-3,j-2) + w(3,3)*y2dv(i-2,j-2) + w(3,4)*y2dv(i-1,j-2) + w(3,5)*y2dv(i,j-2) + w(3,6)*y2dv(i+1,j-2) + w(3,7)*y2dv(i+2,j-2) + &
                  w(3,8)*y2dv(i+3,j-2) + w(3,9)*y2dv(i+4,j-2) + &
                  w(4,1)*y2dv(i-4,j-1) + w(4,2)*y2dv(i-3,j-1) + w(4,3)*y2dv(i-2,j-1) + w(4,4)*y2dv(i-1,j-1) + w(4,5)*y2dv(i,j-1) + w(4,6)*y2dv(i+1,j-1) + w(4,7)*y2dv(i+2,j-1) + &
                  w(4,8)*y2dv(i+3,j-1) + w(4,9)*y2dv(i+4,j-1) + &
                  w(5,1)*y2dv(i-4,j)   + w(5,2)*y2dv(i-3,j)   + w(5,3)*y2dv(i-2,j)   + w(5,4)*y2dv(i-1,j)   + w(5,5)*y2dv(i,j)   + w(5,6)*y2dv(i+1,j)   + w(5,7)*y2dv(i+2,j)   + &
                  w(5,8)*y2dv(i+3,j)   + w(5,9)*y2dv(i+4,j)   + &
                  w(6,1)*y2dv(i-4,j+1) + w(6,2)*y2dv(i-3,j+1) + w(6,3)*y2dv(i-2,j+1) + w(6,4)*y2dv(i-1,j+1) + w(6,5)*y2dv(i,j+1) + w(6,6)*y2dv(i+1,j+1) + w(6,7)*y2dv(i+2,j+1) + &
                  w(6,8)*y2dv(i+3,j+1) + w(6,9)*y2dv(i+4,j+1) + &
                  w(7,1)*y2dv(i-4,j+2) + w(7,2)*y2dv(i-3,j+2) + w(7,3)*y2dv(i-2,j+2) + w(7,4)*y2dv(i-1,j+2) + w(7,5)*y2dv(i,j+2) + w(7,6)*y2dv(i+1,j+2) + w(7,7)*y2dv(i+2,j+2) + &
                  w(7,8)*y2dv(i+3,j+2) + w(7,9)*y2dv(i+4,j+2) + &
                  w(8,1)*y2dv(i-4,j+3) + w(8,2)*y2dv(i-3,j+3) + w(8,3)*y2dv(i-2,j+3) + w(8,4)*y2dv(i-1,j+3) + w(8,5)*y2dv(i,j+3) + w(8,6)*y2dv(i+1,j+3) + w(8,7)*y2dv(i+2,j+3) + &
                  w(8,8)*y2dv(i+3,j+3) + w(8,9)*y2dv(i+4,j+3) + &
                  w(9,1)*y2dv(i-4,j+4) + w(9,2)*y2dv(i-3,j+4) + w(9,3)*y2dv(i-2,j+4) + w(9,4)*y2dv(i-1,j+4) + w(9,5)*y2dv(i,j+4) + w(9,6)*y2dv(i+1,j+4) + w(9,7)*y2dv(i+2,j+4) + &
                  w(9,8)*y2dv(i+3,j+4) + w(9,9)*y2dv(i+4,j+4)   &
                  )/sum_w
       
    END FUNCTION calc_smooth_y2dv_fw9

    SUBROUTINE UPDATE_HX_FW9_WATER_CELL(FW3_WATER_CELL, FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL, i, j)

          INTEGER, INTENT(IN) :: i, j

          LOGICAL, INTENT(INOUT) :: FW3_WATER_CELL, FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL

          REAL(KIND=rsh) :: him4jp4, him3jp4, him2jp4, him1jp4, hijp4, hip1jp4, hip2jp4, hip3jp4, hip4jp4, &
                             him4jp3, him3jp3, him2jp3, him1jp3, hijp3, hip1jp3, hip2jp3, hip3jp3, hip4jp3, &
                             him4jp2, him3jp2, him2jp2, him1jp2, hijp2, hip1jp2, hip2jp2, hip3jp2, hip4jp2, &
                             him4jp1, him3jp1, him2jp1, him1jp1, hijp1, hip1jp1, hip2jp1, hip3jp1, hip4jp1, &
                             him4j,   him3j,   him2j,   him1j,   hij,   hip1j, hip2j,   hip3j,   hip4j,   &
                             him4jm1, him3jm1, him2jm1, him1jm1, hijm1, hip1jm1, hip2jm1, hip3jm1, hip4jm1, &
                             him4jm2, him3jm2, him2jm2, him1jm2, hijm2, hip1jm2, hip2jm2, hip3jm2, hip4jm2, &
                             him4jm3, him3jm3, him2jm3, him1jm3, hijm3, hip1jm3, hip2jm3, hip3jm3, hip4jm3, &
                             him4jm4, him3jm4, him2jm4, him1jm4, hijm4, hip1jm4, hip2jm4, hip3jm4, hip4jm4


          him4jp4 = igdu_ext(i-4,j+4)
          him3jp4 = igdu_ext(i-3,j+4)
          him2jp4 = igdu_ext(i-2,j+4)
          him1jp4 = igdu_ext(i-1,j+4)
          hijp4   = igdu_ext(i,  j+4)
          hip1jp4 = igdu_ext(i+1,j+4)
          hip2jp4 = igdu_ext(i+2,j+4)
          hip3jp4 = igdu_ext(i+3,j+4)
          hip4jp4 = igdu_ext(i+4,j+4)

          him4jp3 = igdu_ext(i-4,j+3)
          him3jp3 = igdu_ext(i-3,j+3)
          him2jp3 = igdu_ext(i-2,j+3)
          him1jp3 = igdu_ext(i-1,j+3)
          hijp3   = igdu_ext(i,  j+3)
          hip1jp3 = igdu_ext(i+1,j+3)
          hip2jp3 = igdu_ext(i+2,j+3)
          hip3jp3 = igdu_ext(i+3,j+3)
          hip4jp3 = igdu_ext(i+4,j+3)

          him4jp2 = igdu_ext(i-4,j+2)
          him3jp2 = igdu_ext(i-3,j+2)
          him2jp2 = igdu_ext(i-2,j+2)
          him1jp2 = igdu_ext(i-1,j+2)
          hijp2   = igdu_ext(i  ,j+2)
          hip1jp2 = igdu_ext(i+1,j+2)
          hip2jp2 = igdu_ext(i+2,j+2)
          hip3jp2 = igdu_ext(i+3,j+2)
          hip4jp2 = igdu_ext(i+4,j+2)

          him4jp1 = igdu_ext(i-4,j+1)
          him3jp1 = igdu_ext(i-3,j+1)
          him2jp1 = igdu_ext(i-2,j+1)
          him1jp1 = igdu_ext(i-1,j+1)
          hijp1   = igdu_ext(i  ,j+1)
          hip1jp1 = igdu_ext(i+1,j+1)
          hip2jp1 = igdu_ext(i+2,j+1)
          hip3jp1 = igdu_ext(i+3,j+1)
          hip4jp1 = igdu_ext(i+4,j+1)

          him4j   = igdu_ext(i-4,j)
          him3j   = igdu_ext(i-3,j)
          him2j   = igdu_ext(i-2,j)
          him1j   = igdu_ext(i-1,j)
          hij     = igdu_ext(i  ,j)
          hip1j   = igdu_ext(i+1,j)
          hip2j   = igdu_ext(i+2,j)
          hip3j   = igdu_ext(i+3,j)
          hip4j   = igdu_ext(i+4,j)

          him4jm1 = igdu_ext(i-4,j-1)
          him3jm1 = igdu_ext(i-3,j-1)
          him2jm1 = igdu_ext(i-2,j-1)
          him1jm1 = igdu_ext(i-1,j-1)
          hijm1   = igdu_ext(i  ,j-1)
          hip1jm1 = igdu_ext(i+1,j-1)
          hip2jm1 = igdu_ext(i+2,j-1)
          hip3jm1 = igdu_ext(i+3,j-1)
          hip4jm1 = igdu_ext(i+4,j-1)

          him4jm2 = igdu_ext(i-4,j-2)
          him3jm2 = igdu_ext(i-3,j-2)
          him2jm2 = igdu_ext(i-2,j-2)
          him1jm2 = igdu_ext(i-1,j-2)
          hijm2   = igdu_ext(i  ,j-2)
          hip1jm2 = igdu_ext(i+1,j-2)
          hip2jm2 = igdu_ext(i+2,j-2)
          hip3jm2 = igdu_ext(i+3,j-2)
          hip4jm2 = igdu_ext(i+4,j-2)

          him4jm3 = igdu_ext(i-4,j-3)
          him3jm3 = igdu_ext(i-3,j-3)
          him2jm3 = igdu_ext(i-2,j-3)
          him1jm3 = igdu_ext(i-1,j-3)
          hijm3   = igdu_ext(i,  j-3)
          hip1jm3 = igdu_ext(i+1,j-3)
          hip2jm3 = igdu_ext(i+2,j-3)
          hip3jm3 = igdu_ext(i+3,j-3)
          hip4jm3 = igdu_ext(i+4,j-3)

          him4jm4 = igdu_ext(i-4,j-4)
          him3jm4 = igdu_ext(i-3,j-4)
          him2jm4 = igdu_ext(i-2,j-4)
          him1jm4 = igdu_ext(i-1,j-4)
          hijm4   = igdu_ext(i,  j-4)
          hip1jm4 = igdu_ext(i+1,j-4)
          hip2jm4 = igdu_ext(i+2,j-4)
          hip3jm4 = igdu_ext(i+3,j-4)
          hip4jm4 = igdu_ext(i+4,j-4)

          FW3_WATER_CELL = (him1jp1 /= 4).AND.(hijp1  /= 4).AND.(hip1jp1  /= 4).AND. &
                            (him1j   /= 4).AND.(hij    /= 4).AND.(hip1j    /= 4).AND. &
                            (him1jm1 /= 4).AND.(hijm1  /= 4).AND.(hip1jm1  /= 4)

          FW5_WATER_CELL = FW3_WATER_CELL.AND. &
                            (him2jp2  /= 4).AND.(him1jp2 /= 4).AND.(hijp2 /= 4).AND.  &
                            (hip1jp2  /= 4).AND.(hip2jp2 /= 4).AND. &
                            (him2jp1  /= 4).AND.(hip2jp1 /= 4).AND. &
                            (him2j    /= 4).AND.(hip2j   /= 4).AND. &
                            (him2jm1  /= 4).AND.(hip2jm1 /= 4).AND. &
                            (him2jm2  /= 4).AND.(him1jm2 /= 4).AND.(hijm2  /= 4).AND. &
                            (hip1jm2  /= 4).AND.(hip2jm2 /= 4)

          FW7_WATER_CELL = FW5_WATER_CELL.AND. &
                            (him3jp3 /= 4).AND.(him2jp3 /= 4).AND.(him1jp3 /= 4).AND. &
                            (hijp3   /= 4).AND.(hip1jp3 /= 4).AND.(hip2jp3 /= 4).AND.(hip3jp3 /= 4).AND. &
                            (him3jp2 /= 4).AND.(hip3jp2 /= 4).AND. &
                            (him3jp1 /= 4).AND.(hip3jp1 /= 4).AND. &
                            (him3j   /= 4).AND.(hip3j   /= 4).AND. &
                            (him3jm1 /= 4).AND.(hip3jm1 /= 4).AND. &
                            (him3jm2 /= 4).AND.(hip3jm2 /= 4).AND. &
                            (him3jm3 /= 4).AND.(him2jm3 /= 4).AND.(him1jm3 /= 4).AND. &
                            (hijm3   /= 4).AND.(hip1jm3 /= 4).AND.(hip2jm3 /= 4).AND.(hip3jm3 /= 4)

          FW9_WATER_CELL = FW7_WATER_CELL.AND. &
                           (him4jp4 /= 4).AND.(him3jp4 /= 4).AND.(him2jp4 /= 4).AND. &
                           (him1jp4 /= 4).AND.(hijp4   /= 4).AND.(hip1jp4 /= 4).AND. &
                           (hip2jp4 /= 4).AND.(hip3jp4 /= 4).AND.(hip4jp4 /= 4).AND. &
                           (him4jp3 /= 4).AND.(hip4jp3 /= 4).AND. &
                           (him4jp2 /= 4).AND.(hip4jp2 /= 4).AND. &
                           (him4jp1 /= 4).AND.(hip4jp1 /= 4).AND. &
                           (him4j   /= 4).AND.(hip4j   /= 4).AND. &
                           (him4jm1 /= 4).AND.(hip4jm1 /= 4).AND. &
                           (him4jm2 /= 4).AND.(hip4jm2 /= 4).AND. &
                           (him4jm3 /= 4).AND.(hip4jm3 /= 4).AND. &
                           (him4jm4 /= 4).AND.(him3jm4 /= 4).AND.(him2jm4 /= 4).AND. &
                           (him1jm4 /= 4).AND.(hijm4   /= 4).AND.(hip1jm4 /= 4).AND. &
                           (hip2jm4 /= 4).AND.(hip3jm4 /= 4).AND.(hip4jm4 /= 4)

    END SUBROUTINE UPDATE_HX_FW9_WATER_CELL


    SUBROUTINE UPDATE_HY_FW9_WATER_CELL(FW3_WATER_CELL, FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL, i, j)

          INTEGER, INTENT(IN) :: i, j

          LOGICAL, INTENT(INOUT) :: FW3_WATER_CELL, FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL

          REAL(KIND=rsh) :: him4jp4, him3jp4, him2jp4, him1jp4, hijp4, hip1jp4, hip2jp4, hip3jp4, hip4jp4, &
                            him4jp3, him3jp3, him2jp3, him1jp3, hijp3, hip1jp3, hip2jp3, hip3jp3, hip4jp3, &
                            him4jp2, him3jp2, him2jp2, him1jp2, hijp2, hip1jp2, hip2jp2, hip3jp2, hip4jp2, &
                            him4jp1, him3jp1, him2jp1, him1jp1, hijp1, hip1jp1, hip2jp1, hip3jp1, hip4jp1, &
                            him4j,   him3j,   him2j,   him1j,   hij,   hip1j, hip2j,   hip3j,   hip4j,   &
                            him4jm1, him3jm1, him2jm1, him1jm1, hijm1, hip1jm1, hip2jm1, hip3jm1, hip4jm1, &
                            him4jm2, him3jm2, him2jm2, him1jm2, hijm2, hip1jm2, hip2jm2, hip3jm2, hip4jm2, &
                            him4jm3, him3jm3, him2jm3, him1jm3, hijm3, hip1jm3, hip2jm3, hip3jm3, hip4jm3, &
                            him4jm4, him3jm4, him2jm4, him1jm4, hijm4, hip1jm4, hip2jm4, hip3jm4, hip4jm4


          him4jp4 = igdv_ext(i-4,j+4)
          him3jp4 = igdv_ext(i-3,j+4)
          him2jp4 = igdv_ext(i-2,j+4)
          him1jp4 = igdv_ext(i-1,j+4)
          hijp4   = igdv_ext(i,  j+4)
          hip1jp4 = igdv_ext(i+1,j+4)
          hip2jp4 = igdv_ext(i+2,j+4)
          hip3jp4 = igdv_ext(i+3,j+4)
          hip4jp4 = igdv_ext(i+4,j+4)

          him4jp3 = igdv_ext(i-4,j+3)
          him3jp3 = igdv_ext(i-3,j+3)
          him2jp3 = igdv_ext(i-2,j+3)
          him1jp3 = igdv_ext(i-1,j+3)
          hijp3   = igdv_ext(i,  j+3)
          hip1jp3 = igdv_ext(i+1,j+3)
          hip2jp3 = igdv_ext(i+2,j+3)
          hip3jp3 = igdv_ext(i+3,j+3)
          hip4jp3 = igdv_ext(i+4,j+3)

          him4jp2 = igdv_ext(i-4,j+2)
          him3jp2 = igdv_ext(i-3,j+2)
          him2jp2 = igdv_ext(i-2,j+2)
          him1jp2 = igdv_ext(i-1,j+2)
          hijp2   = igdv_ext(i  ,j+2)
          hip1jp2 = igdv_ext(i+1,j+2)
          hip2jp2 = igdv_ext(i+2,j+2)
          hip3jp2 = igdv_ext(i+3,j+2)
          hip4jp2 = igdv_ext(i+4,j+2)

          him4jp1 = igdv_ext(i-4,j+1)
          him3jp1 = igdv_ext(i-3,j+1)
          him2jp1 = igdv_ext(i-2,j+1)
          him1jp1 = igdv_ext(i-1,j+1)
          hijp1   = igdv_ext(i  ,j+1)
          hip1jp1 = igdv_ext(i+1,j+1)
          hip2jp1 = igdv_ext(i+2,j+1)
          hip3jp1 = igdv_ext(i+3,j+1)
          hip4jp1 = igdv_ext(i+4,j+1)

          him4j   = igdv_ext(i-4,j)
          him3j   = igdv_ext(i-3,j)
          him2j   = igdv_ext(i-2,j)
          him1j   = igdv_ext(i-1,j)
          hij     = igdv_ext(i  ,j)
          hip1j   = igdv_ext(i+1,j)
          hip2j   = igdv_ext(i+2,j)
          hip3j   = igdv_ext(i+3,j)
          hip4j   = igdv_ext(i+4,j)

          him4jm1 = igdv_ext(i-4,j-1)
          him3jm1 = igdv_ext(i-3,j-1)
          him2jm1 = igdv_ext(i-2,j-1)
          him1jm1 = igdv_ext(i-1,j-1)
          hijm1   = igdv_ext(i  ,j-1)
          hip1jm1 = igdv_ext(i+1,j-1)
          hip2jm1 = igdv_ext(i+2,j-1)
          hip3jm1 = igdv_ext(i+3,j-1)
          hip4jm1 = igdv_ext(i+4,j-1)

          him4jm2 = igdv_ext(i-4,j-2)
          him3jm2 = igdv_ext(i-3,j-2)
          him2jm2 = igdv_ext(i-2,j-2)
          him1jm2 = igdv_ext(i-1,j-2)
          hijm2   = igdv_ext(i  ,j-2)
          hip1jm2 = igdv_ext(i+1,j-2)
          hip2jm2 = igdv_ext(i+2,j-2)
          hip3jm2 = igdv_ext(i+3,j-2)
          hip4jm2 = igdv_ext(i+4,j-2)

          him4jm3 = igdv_ext(i-4,j-3)
          him3jm3 = igdv_ext(i-3,j-3)
          him2jm3 = igdv_ext(i-2,j-3)
          him1jm3 = igdv_ext(i-1,j-3)
          hijm3   = igdv_ext(i,  j-3)
          hip1jm3 = igdv_ext(i+1,j-3)
          hip2jm3 = igdv_ext(i+2,j-3)
          hip3jm3 = igdv_ext(i+3,j-3)
          hip4jm3 = igdv_ext(i+4,j-3)

          him4jm4 = igdv_ext(i-4,j-4)
          him3jm4 = igdv_ext(i-3,j-4)
          him2jm4 = igdv_ext(i-2,j-4)
          him1jm4 = igdv_ext(i-1,j-4)
          hijm4   = igdv_ext(i,  j-4)
          hip1jm4 = igdv_ext(i+1,j-4)
          hip2jm4 = igdv_ext(i+2,j-4)
          hip3jm4 = igdv_ext(i+3,j-4)
          hip4jm4 = igdv_ext(i+4,j-4)

           FW3_WATER_CELL = (him1jp1 /= 4).AND.(hijp1  /= 4).AND.(hip1jp1  /= 4).AND. &
                            (him1j   /= 4).AND.(hij    /= 4).AND.(hip1j    /= 4).AND. &
                            (him1jm1 /= 4).AND.(hijm1  /= 4).AND.(hip1jm1  /= 4)

           FW5_WATER_CELL = FW3_WATER_CELL.AND. &
                            (him2jp2  /= 4).AND.(him1jp2 /= 4).AND.(hijp2 /= 4).AND.  &
                            (hip1jp2  /= 4).AND.(hip2jp2 /= 4).AND. &
                            (him2jp1  /= 4).AND.(hip2jp1 /= 4).AND. &
                            (him2j    /= 4).AND.(hip2j   /= 4).AND. &
                            (him2jm1  /= 4).AND.(hip2jm1 /= 4).AND. &
                            (him2jm2  /= 4).AND.(him1jm2 /= 4).AND.(hijm2  /= 4).AND. &
                            (hip1jm2  /= 4).AND.(hip2jm2 /= 4)

           FW7_WATER_CELL = FW5_WATER_CELL.AND. &
                            (him3jp3 /= 4).AND.(him2jp3 /= 4).AND.(him1jp3 /= 4).AND. &
                            (hijp3   /= 4).AND.(hip1jp3 /= 4).AND.(hip2jp3 /= 4).AND.(hip3jp3 /= 4).AND. &
                            (him3jp2 /= 4).AND.(hip3jp2 /= 4).AND. &
                            (him3jp1 /= 4).AND.(hip3jp1 /= 4).AND. &
                            (him3j   /= 4).AND.(hip3j   /= 4).AND. &
                            (him3jm1 /= 4).AND.(hip3jm1 /= 4).AND. &
                            (him3jm2 /= 4).AND.(hip3jm2 /= 4).AND. &
                            (him3jm3 /= 4).AND.(him2jm3 /= 4).AND.(him1jm3 /= 4).AND. &
                            (hijm3   /= 4).AND.(hip1jm3 /= 4).AND.(hip2jm3 /= 4).AND.(hip3jm3 /= 4)

          FW9_WATER_CELL = FW7_WATER_CELL.AND. &
                           (him4jp4 /= 4).AND.(him3jp4 /= 4).AND.(him2jp4 /= 4).AND. &
                           (him1jp4 /= 4).AND.(hijp4   /= 4).AND.(hip1jp4 /= 4).AND. &
                           (hip2jp4 /= 4).AND.(hip3jp4 /= 4).AND.(hip4jp4 /= 4).AND. &
                           (him4jp3 /= 4).AND.(hip4jp3 /= 4).AND. &
                           (him4jp2 /= 4).AND.(hip4jp2 /= 4).AND. &
                           (him4jp1 /= 4).AND.(hip4jp1 /= 4).AND. &
                           (him4j   /= 4).AND.(hip4j   /= 4).AND. &
                           (him4jm1 /= 4).AND.(hip4jm1 /= 4).AND. &
                           (him4jm2 /= 4).AND.(hip4jm2 /= 4).AND. &
                           (him4jm3 /= 4).AND.(hip4jm3 /= 4).AND. &
                           (him4jm4 /= 4).AND.(him3jm4 /= 4).AND.(him2jm4 /= 4).AND. &
                           (him1jm4 /= 4).AND.(hijm4   /= 4).AND.(hip1jm4 /= 4).AND. &
                           (hip2jm4 /= 4).AND.(hip3jm4 /= 4).AND.(hip4jm4 /= 4)

    END SUBROUTINE UPDATE_HY_FW9_WATER_CELL

    SUBROUTINE smoothuInd_fw9

           IMPLICIT NONE

           LOGICAL :: FW3_WATER_CELL, FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL

           INTEGER :: i, j

!$OMP DO SCHEDULE(runtime)
           DO j=ljmin,ljmax
                DO i=limin,limax
                      IF (i >= imin+5 .AND. i <= imax-5 .AND. j >= jmin+6 .AND. j <= jmax-5) THEN

                               CALL UPDATE_HX_FW9_WATER_CELL(FW3_WATER_CELL,FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL, i, j)

                               IF (FW9_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 9.0_rsh

                               ELSE IF (FW7_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 7.0_rsh

                               ELSE IF (FW5_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 5.0_rsh

                               ELSE IF (FW3_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 3.0_rsh
                               ELSE
                                        Indu(i,j) = 0.0_rsh
                               END IF

                      ELSE IF (i >= imin+4 .AND. i <= imax-4 .AND. j >= jmin+5 .AND. j <= jmax-4) THEN

                               CALL UPDATE_HX_FW7_WATER_CELL(FW3_WATER_CELL,FW5_WATER_CELL, FW7_WATER_CELL, i, j)

                               IF (FW7_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 7.0_rsh

                               ELSE IF (FW5_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 5.0_rsh

                               ELSE IF (FW3_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 3.0_rsh
                               ELSE
                                        Indu(i,j) = 0.0_rsh
                               END IF

                       ELSE IF (i >= imin+3 .AND. i <= imax-3 .AND. j >= jmin+4 .AND. j <= jmax-3) THEN

                               CALL UPDATE_HX_FW5_WATER_CELL(FW3_WATER_CELL,FW5_WATER_CELL, i, j)

                               IF (FW5_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 5.0_rsh

                               ELSE IF (FW3_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 3.0_rsh
                               ELSE
                                        Indu(i,j) = 0.0_rsh
                               END IF


                        ELSE IF (i >= imin+2 .AND. i <= imax-2 .AND. j >= jmin+3 .AND. j <= jmax-2) THEN

                                CALL UPDATE_HX_FW3_WATER_CELL(FW3_WATER_CELL,i,j)

                                IF (FW3_WATER_CELL == .TRUE.) THEN

                                        Indu(i,j) = 3.0_rsh
                                ELSE
                                        Indu(i,j) = 0.0_rsh

                                END IF
                       END IF
                  
              END DO
           END DO
!$OMP END DO
    END SUBROUTINE smoothuInd_fw9

    SUBROUTINE smoothvInd_fw9

           IMPLICIT NONE

           LOGICAL :: FW3_WATER_CELL, FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL

           INTEGER :: i, j

!$OMP DO SCHEDULE(runtime)
           DO j=ljmin,ljmax
                DO i=limin,limax

                       IF (i >= imin+6 .AND. i <= imax-5 .AND. j >= jmin+5 .AND. j <= jmax-5) THEN

                               CALL UPDATE_HY_FW9_WATER_CELL(FW3_WATER_CELL,FW5_WATER_CELL, FW7_WATER_CELL, FW9_WATER_CELL, i, j)

                               IF (FW9_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 9.0_rsh

                               ELSE IF (FW7_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 7.0_rsh

                               ELSE IF (FW5_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 5.0_rsh

                               ELSE IF (FW3_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 3.0_rsh
                               ELSE
                                        Indv(i,j) = 0.0_rsh
                               END IF

                       ELSE IF (i >= imin+5 .AND. i <= imax-4 .AND. j >= jmin+4 .AND. j <= jmax-4) THEN

                               CALL UPDATE_HY_FW7_WATER_CELL(FW3_WATER_CELL,FW5_WATER_CELL, FW7_WATER_CELL, i, j)

                               IF (FW7_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 7.0_rsh

                               ELSE IF (FW5_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 5.0_rsh

                               ELSE IF (FW3_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 3.0_rsh
                               ELSE
                                        Indv(i,j) = 0.0_rsh
                               END IF
                        
                       ELSE IF (i >= imin+4 .AND. i <= imax-3 .AND. j >= jmin+3 .AND. j <= jmax-3) THEN

                               CALL UPDATE_HY_FW5_WATER_CELL(FW3_WATER_CELL, FW5_WATER_CELL, i, j)

                               IF (FW5_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 5.0_rsh

                               ELSE IF (FW3_WATER_CELL == .TRUE.) THEN

                                        Indv(i,j) = 3.0_rsh
                               ELSE
                                        Indv(i,j) = 0.0_rsh
                               END IF


                        ELSE IF (i >= imin+3 .AND. i <= imax-2 .AND. j >= jmin+2 .AND. j <= jmax-2) THEN

                               CALL UPDATE_HY_FW3_WATER_CELL(FW3_WATER_CELL, i, j)

                               IF (FW3_WATER_CELL == .TRUE.) THEN

                                       Indv(i,j) = 3.0_rsh
                               ELSE
                                       Indv(i,j) = 0.0_rsh

                               END IF
                       END IF
               END DO
           END DO
!$OMP END DO
    END SUBROUTINE smoothvInd_fw9

    SUBROUTINE smoothu_fw9(u, us)

           IMPLICIT NONE

           REAL(KIND=rsh), DIMENSION(liminm4:limaxp4,ljminm4:ljmaxp4),INTENT(IN) :: u

           REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2),INTENT(INOUT) :: us

           !! * Local declarations
           INTEGER :: i, j

!$OMP DO SCHEDULE(runtime)
           DO j=ljmin,ljmax
                DO i=limin,limax

                        IF (Indu(i,j) == 9.0_rsh) THEN

                                us(i,j) = calc_smooth_vel_fw9(u, weight_fw9, sum_fw9, i, j)

                        ELSE IF (Indu(i,j) == 7.0_rsh) THEN

                                us(i,j) = calc_smooth_vel_fw7(u, weight_fw9, sum_fw7, i, j)

                        ELSE IF (Indu(i,j) == 5.0_rsh) THEN

                                us(i,j) = calc_smooth_vel_fw5(u, weight_fw9, sum_fw5, i, j)

                        ELSE IF (Indu(i,j) == 3.0_rsh) THEN

                                us(i,j) = calc_smooth_vel_fw3(u, weight_fw9, sum_fw3, i, j)
                        ELSE
                                us(i,j) = u(i,j)
                        END IF
                END DO
           END DO
!$OMP END DO
    END SUBROUTINE smoothu_fw9

    SUBROUTINE smoothy2du_fw9(y2dv, y2dvs)

           IMPLICIT NONE

           REAL(KIND=rlg), DIMENSION(liminm4:limaxp4,ljminm4:ljmaxp4),INTENT(IN) :: y2dv

           REAL(KIND=rlg), DIMENSION(liminm1:limax,ljminm1:ljmax),INTENT(INOUT)  :: y2dvs
           
           !! * Local declarations
           INTEGER :: i, j

!$OMP DO SCHEDULE(runtime)
           DO j=ljmin,ljmax
                DO i=limin,limax

                        IF (Indu(i,j) == 9.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw9(y2dv, weight_fw9, sum_fw9, i, j)

                         ELSE IF (Indu(i,j) == 7.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw7(y2dv, weight_fw9, sum_fw7, i, j)

                         ELSE IF (Indu(i,j) == 5.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw5(y2dv, weight_fw9, sum_fw5, i, j)

                         ELSE IF (Indu(i,j) == 3.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw3(y2dv, weight_fw9, sum_fw3, i, j)
                         ELSE
                                y2dvs(i,j) = y2dv(i,j)
                         END IF
                END DO
           END DO
!$OMP END DO
    END SUBROUTINE smoothy2du_fw9

    SUBROUTINE smoothv_fw9(v, vs)

           IMPLICIT NONE

           REAL(KIND=rsh), DIMENSION(liminm4:limaxp4,ljminm4:ljmaxp4),INTENT(IN) :: v

           REAL(KIND=rsh), DIMENSION(liminm2:limaxp2,ljminm2:ljmaxp2),INTENT(INOUT) :: vs
        
           !! * Local declarations
           INTEGER :: i, j

!$OMP DO SCHEDULE(runtime)
           DO j=ljmin,ljmax
                DO i=limin,limax
                        IF (Indv(i,j) == 9.0_rsh) THEN

                                vs(i,j) = calc_smooth_vel_fw9(v, weight_fw9, sum_fw9, i, j)

                         ELSE IF (Indv(i,j) == 7.0_rsh) THEN

                                vs(i,j) = calc_smooth_vel_fw7(v, weight_fw9, sum_fw7, i, j)

                          ELSE IF (Indv(i,j) == 5.0_rsh) THEN

                                vs(i,j) = calc_smooth_vel_fw5(v, weight_fw9, sum_fw5, i, j)

                          ELSE IF (Indv(i,j) == 3.0_rsh) THEN

                                vs(i,j) = calc_smooth_vel_fw3(v, weight_fw9, sum_fw3, i, j)
                          ELSE
                                vs(i,j) = v(i,j)
                          END IF
               END DO
           END DO
!$OMP END DO         
    END SUBROUTINE smoothv_fw9

    SUBROUTINE smoothy2dv_fw9(y2dv, y2dvs)

           IMPLICIT NONE

           REAL(KIND=rlg), DIMENSION(liminm4:limaxp4,ljminm4:ljmaxp4),INTENT(IN) :: y2dv

           REAL(KIND=rlg), DIMENSION(liminm1:limax,ljminm1:ljmax),INTENT(INOUT)  :: y2dvs
           
           !! * Local declarations
           INTEGER :: i, j

!$OMP DO SCHEDULE(runtime)
        DO j=ljmin,ljmax
                DO i=limin,limax
                        IF (Indv(i,j) == 9.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw9(y2dv, weight_fw9, sum_fw9, i, j)                                       

                        ELSE IF (Indv(i,j) == 7.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw7(y2dv, weight_fw9, sum_fw7, i, j)

                        ELSE IF (Indv(i,j) == 5.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw5(y2dv, weight_fw9, sum_fw5, i, j)

                        ELSE IF (Indv(i,j) == 3.0_rsh) THEN

                                y2dvs(i,j) = calc_smooth_y2dv_fw3(y2dv, weight_fw9, sum_fw3, i, j)
                        ELSE
                                y2dvs(i,j) = y2dv(i,j)
                        END IF
                END DO
        END DO
!$OMP END DO
    END SUBROUTINE smoothy2dv_fw9
#endif
END MODULE smooth_fw9
