MODULE weighting 

#if defined key_lans_turb || defined key_leray_turb

 USE parameters, ONLY : rsh, aws, bws, cws, dws, ews, filter_width

 IMPLICIT NONE

 REAL(kind=rsh),ALLOCATABLE,DIMENSION(:,:) :: weight_fw3, weight_fw5, weight_fw7, weight_fw9

 REAL(KIND=rsh) :: sum_fw3, sum_fw5, sum_fw7, sum_fw9

 CONTAINS

        SUBROUTINE weighting_fw3(w)

                IMPLICIT NONE

                !INPOUT-OUTPUT
                REAL(kind=rsh), DIMENSION(1:9,1:9), INTENT(INOUT) :: w

                w(4,4) = bws*bws
                w(4,5) = bws
                w(4,6) = bws*bws

                w(5,4) = bws
                w(5,5) = aws
                w(5,6) = bws

                w(6,4) = bws*bws
                w(6,5) = bws
                w(6,6) = bws*bws

                sum_fw3 = aws + 4*(bws*bws + bws)

        END SUBROUTINE weighting_fw3

        SUBROUTINE weighting_fw5(w)

                IMPLICIT NONE

                !INPOUT-OUTPUT
                REAL(kind=rsh), DIMENSION(1:9,1:9), INTENT(INOUT) :: w


                w(3,3) = cws*cws
                w(3,4) = cws*bws
                w(3,5) = cws
                w(3,6) = cws*bws
                w(3,7) = cws*cws

                w(4,3) = bws*cws
                w(4,4) = bws*bws
                w(4,5) = bws
                w(4,6) = bws*bws
                w(4,7) = bws*cws

                w(5,3) = cws
                w(5,4) = bws
                w(5,5) = aws
                w(5,6) = bws
                w(5,7) = cws

                w(6,3) = bws*cws
                w(6,4) = bws*bws
                w(6,5) = bws
                w(6,6) = bws*bws
                w(6,7) = bws*cws

                w(7,3) = cws*cws
                w(7,4) = cws*bws
                w(7,5) = cws
                w(7,6) = cws*bws
                w(7,7) = cws*cws

                sum_fw3 = aws + 4*(bws*bws + bws)
                sum_fw5 = sum_fw3 + 4*(cws*cws + cws) + 8*cws*bws

        END SUBROUTINE weighting_fw5

        SUBROUTINE weighting_fw7(w)

                IMPLICIT NONE

                !INPOUT-OUTPUT
                REAL(kind=rsh), DIMENSION(1:9,1:9), INTENT(INOUT) :: w

                w(2,2) = dws*dws
                w(2,3) = dws*cws
                w(2,4) = dws*bws
                w(2,5) = dws
                w(2,6) = dws*bws
                w(2,7) = dws*cws
                w(2,8) = dws*dws

                w(3,2) = cws*dws
                w(3,3) = cws*cws
                w(3,4) = cws*bws
                w(3,5) = cws
                w(3,6) = cws*bws
                w(3,7) = cws*cws
                w(3,8) = cws*dws

                w(4,2) = bws*dws
                w(4,3) = bws*cws
                w(4,4) = bws*bws
                w(4,5) = bws
                w(4,6) = bws*bws
                w(4,7) = bws*cws
                w(4,8) = bws*dws

                w(5,2) = dws
                w(5,3) = cws
                w(5,4) = bws
                w(5,5) = aws
                w(5,6) = bws
                w(5,7) = cws
                w(5,8) = dws

                w(6,2) = bws*dws
                w(6,3) = bws*cws
                w(6,4) = bws*bws
                w(6,5) = bws
                w(6,6) = bws*bws
                w(6,7) = bws*cws
                w(6,8) = bws*dws

                w(7,2) = cws*dws
                w(7,3) = cws*cws
                w(7,4) = cws*bws
                w(7,5) = cws
                w(7,6) = cws*bws
                w(7,7) = cws*cws
                w(7,8) = cws*dws

                w(8,2) = dws*dws
                w(8,3) = dws*cws
                w(8,4) = dws*bws
                w(8,5) = dws
                w(8,6) = dws*bws
                w(8,7) = dws*cws
                w(8,8) = dws*dws

                sum_fw3 = aws + 4*(bws*bws + bws)
                sum_fw5 = sum_fw3 + 4*(cws*cws + cws) + 8*cws*bws
                sum_fw7 = sum_fw5 + 4*(dws*dws + dws) + 8*(dws*bws+dws*cws)
          
        END SUBROUTINE weighting_fw7

        SUBROUTINE weighting_fw9(w)

                IMPLICIT NONE

                !INPOUT-OUTPUT
                REAL(kind=rsh), DIMENSION(1:9,1:9), INTENT(INOUT) :: w

                w(1,1) = ews*ews
                w(1,2) = ews*dws
                w(1,3) = ews*cws
                w(1,4) = ews*bws
                w(1,5) = ews
                w(1,6) = ews*bws
                w(1,7) = ews*cws
                w(1,8) = ews*dws
                w(1,9) = ews*ews

                w(2,1) = dws*ews
                w(2,2) = dws*dws
                w(2,3) = dws*cws
                w(2,4) = dws*bws
                w(2,5) = dws
                w(2,6) = dws*bws
                w(2,7) = dws*cws
                w(2,8) = dws*dws
                w(2,9) = dws*ews

                w(3,1) = cws*ews
                w(3,2) = cws*dws
                w(3,3) = cws*cws
                w(3,4) = cws*bws
                w(3,5) = cws
                w(3,6) = cws*bws
                w(3,7) = cws*cws
                w(3,8) = cws*dws
                w(3,9) = cws*ews

                w(4,1) = bws*ews
                w(4,2) = bws*dws
                w(4,3) = bws*cws
                w(4,4) = bws*bws
                w(4,5) = bws
                w(4,6) = bws*bws
                w(4,7) = bws*cws
                w(4,8) = bws*dws
                w(4,9) = bws*ews

                w(5,1) = ews
                w(5,2) = dws
                w(5,3) = cws
                w(5,4) = bws
                w(5,5) = aws
                w(5,6) = bws
                w(5,7) = cws
                w(5,8) = dws
                w(5,9) = ews

                w(6,1) = bws*ews
                w(6,2) = bws*dws
                w(6,3) = bws*cws
                w(6,4) = bws*bws
                w(6,5) = bws
                w(6,6) = bws*bws
                w(6,7) = bws*cws
                w(6,8) = bws*dws
                w(6,9) = bws*ews

                w(7,1) = cws*ews
                w(7,2) = cws*dws
                w(7,3) = cws*cws
                w(7,4) = cws*bws
                w(7,5) = cws
                w(7,6) = cws*bws
                w(7,7) = cws*cws
                w(7,8) = cws*dws
                w(7,9) = cws*ews

                w(8,1) = dws*ews
                w(8,2) = dws*dws
                w(8,3) = dws*cws
                w(8,4) = dws*bws
                w(8,5) = dws
                w(8,6) = dws*bws
                w(8,7) = dws*cws
                w(8,8) = dws*dws
                w(8,9) = dws*ews

                w(9,1) = ews*ews
                w(9,2) = ews*dws
                w(9,3) = ews*cws
                w(9,4) = ews*bws
                w(9,5) = ews
                w(9,6) = ews*bws
                w(9,7) = ews*cws
                w(9,8) = ews*dws
                w(9,9) = ews*ews

                sum_fw3 = aws     + 4*(bws*bws + bws)
                sum_fw5 = sum_fw3 + 4*(cws*cws + cws) + 8*cws*bws
                sum_fw7 = sum_fw5 + 4*(dws*dws + dws) + 8*(dws*bws+dws*cws)
                sum_fw9 = sum_fw7 + 4*(ews*ews + ews) + 8*(ews*bws+ews*cws+ ews*dws) 

        END SUBROUTINE weighting_fw9

        SUBROUTINE alloc_weight

!&E--------------------------------------------------------------------------
!&E                 ***  ROUTINE dealloc_comvars2d_grid  ***
!&E
!&E--------------------------------------------------------------------------
!! * Modules used
                IMPLICIT NONE

!!----------------------------------------------------------------------
!! * Executable part

                ALLOCATE(weight_fw3(1:9,1:9))
                ALLOCATE(weight_fw5(1:9,1:9))
                ALLOCATE(weight_fw7(1:9,1:9))
                ALLOCATE(weight_fw9(1:9,1:9))

                weight_fw3(:,:) = 0.0_rsh
                weight_fw5(:,:) = 0.0_rsh
                weight_fw7(:,:) = 0.0_rsh
                weight_fw9(:,:) = 0.0_rsh

                 
        END SUBROUTINE alloc_weight

        SUBROUTINE calc_smooth_weight(w_fw3, w_fw5, w_fw7, w_fw9)

                IMPLICIT NONE

                !INPOUT-OUTPUT
                REAL(kind=rsh), DIMENSION(1:9,1:9), INTENT(INOUT) :: w_fw3, w_fw5, w_fw7, w_fw9

                IF (filter_width==3) CALL weighting_fw3(w_fw3)

                IF (filter_width==5) CALL weighting_fw5(w_fw5)

                IF (filter_width==7) CALL weighting_fw7(w_fw7)

                IF (filter_width==9) CALL weighting_fw9(w_fw9)
                
        END SUBROUTINE calc_smooth_weight

        SUBROUTINE dealloc_weight

        !&E--------------------------------------------------------------------------
        !&E                 ***  ROUTINE dealloc_comvars2d_grid  ***
        !&E
        !&E--------------------------------------------------------------------------
                !! * Modules used
                IMPLICIT NONE

                !!----------------------------------------------------------------------
                !! * Executable part

                DEALLOCATE(weight_fw3, weight_fw5, weight_fw7, weight_fw9)

        END SUBROUTINE dealloc_weight
#endif
END MODULE weighting 
