  FUNCTION tool_ind2lon(x,y)
 
   !&E---------------------------------------------------------------------
   !&E                 ***  FUNCTION tool_ind2lon  ***
   !&E
   !&E ** Purpose : convert the grid index into a longitude
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by : paramet,init
   !&E
   !&E ** External calls : 
   !&E
   !&E ** Used ij-arrays : 
   !&E
   !&E ** Modified variables : tool_ind2lon
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  2004-10-28
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used
   USE parameters
   USE comvars2d

   IMPLICIT NONE

   !! * Function declaration
   REAL(kind=rlg)             :: tool_ind2lon

   !! * Arguments
   REAL(kind=rsh),INTENT(in)  :: x,y

   !!----------------------------------------------------------------------
   !! * Executable part

#ifdef key_grid_rotated
   ! not correct because useful for trajectories for which x,y must be a real to get the exact
   ! location inside the cell...
   tool_ind2lon=lon2d_g(INT(x),INT(y))
#else
   tool_ind2lon=gwac+(REAL(x,riolg)-1.0_riolg)*dgac
#endif

  END FUNCTION tool_ind2lon
