 MODULE comtraj
   !!======================================================================
   !!                   ***  MODULE comtraj  ***
   !!
   !!======================================================================
   USE parameters, ONLY       : rsh,rlg,lchain

   !! * Shared module variables
   TYPE,PUBLIC :: base_3d_part

#ifdef key_MPI_2D
     ! MPI managing
     !-----------------
     LOGICAL :: inoutflag    ! .True. if stays in the cpu domain,
                             ! .False. if crosses the boundaries (limimX,limaxpX,ljminmX,ljmaxpX)

     INTEGER :: limitbye     ! Specify the direction of the boundary crossing
                             ! 1=S, 2=W cval2tina
#endif

     INTEGER :: itypevert    ! type of trajectory (z=cst, random walk...)
     INTEGER :: num          ! to keep track of particles when save/restart 
     INTEGER :: fake

#ifdef key_ibm
     !Biological parameters
     ! If you add/remove some attribute variables, then update nbvartraj_int
     INTEGER        :: stage,fake2
#ifdef key_anchovy
     INTEGER        :: dayjuv 
     INTEGER        :: dayspawn
     INTEGER        :: yearspawn
     INTEGER        :: hmove
     INTEGER        :: season
     INTEGER        :: fake3
#endif 
#endif

     ! main properties
     !-----------------
     REAL(KIND=rlg) :: date_orig   ! date of release

     ! location
     !-----------------
!     REAL(KIND=rlg) :: lat,lon
     REAL(KIND=rsh) :: xpos,ypos,spos,zpos,d3,h0,xe,hc
     REAL(KIND=rsh) :: flag,fake4   ! wet-drying flag

#ifdef key_ibm
     !Biological parameters
     ! If you add/remove some attribute variables, then update nbvartraj_rsh
     REAL(KIND=rsh) :: w,size,density,Drate
     REAL(KIND=rsh) :: temp
     REAL(KIND=rsh) :: super ! one part represent number individuals (superindividual)
#ifdef key_anchovy
 !DEB state variables and parameters
     REAL(KIND=rsh) :: E,L,H,R,Gam,X,Wdeb,Neggs,NRJ
     REAL(KIND=rsh) :: denspawn
#endif
#endif

   END TYPE base_3d_part

   !   ----------------------------------------
   ! Number of variables describing a particule according to their type

#ifdef key_MPI_2D
     ! MPI managing
     !-----------------
#ifdef key_ibm
   ! count the nb of variables you have added for key_ibm (by type) and add it to the numbers relative to the physics only
   INTEGER, PARAMETER, PUBLIC :: nbvartraj_log = 1, &   ! logical
                                 nbvartraj_rlg = 1, &   ! long real (double precision)
#ifdef key_anchovy
                                 nbvartraj_int = 12, &   ! integer
                                 nbvartraj_rsh = 26     ! short real (single precision) 
#else
                                 nbvartraj_int = 6, &   ! integer
                                 nbvartraj_rsh = 16     ! short real (single precision)
#endif
#else
   ! basic variables describing a particule (physics)
   INTEGER, PARAMETER, PUBLIC :: nbvartraj_log = 1, &   ! logical
                                 nbvartraj_int = 4, &   ! integer
                                 nbvartraj_rlg = 1, &   ! long real (double precision)
                                 nbvartraj_rsh = 10     ! short real (single precision)
#endif
#endif

   !   ----------------------------------------

   TYPE(base_3d_part),ALLOCATABLE,DIMENSION(:,:),PUBLIC :: part

                   ! number of patches
   INTEGER                                      :: nb_patch
                   ! number of particles inside each patch
   INTEGER, ALLOCATABLE, DIMENSION(:)           :: nb_part
                   ! maximum number of particles
   INTEGER                                      :: nbmax_part
                   ! number of particles per cpu
   INTEGER, DIMENSION(:,:), ALLOCATABLE         :: nb_part_percpu

   CHARACTER(LEN=lchain), PUBLIC      :: file_trajec

#ifdef key_MPI_2D
   INTEGER :: down_give,up_give,right_give,left_give
#endif

                   ! name of trajectories output files
   CHARACTER(LEN=lchain), ALLOCATABLE, DIMENSION(:)  :: filetraj3dout,filetrajin
                   ! starting and endind date of trajectories
   REAL(KIND=rlg), ALLOCATABLE, DIMENSION(:)    :: tbegtraj,tendtraj,tsavtraj,dtsave_traj
                   ! number of time step division for vertical subloop
   INTEGER                                      :: ndtz
                   ! initialisation type (circle, rectangle,netcdf)
   INTEGER                                      :: itypetraj
                   ! type of vertical displacement coded as an integer
   INTEGER, ALLOCATABLE, DIMENSION(:)           :: itypevert


 END MODULE
